﻿using System;
using System.IO;
using System.Text;
using System.Threading.Tasks;
using System.Web;

public class AsyncRequestLogModule : IHttpModule
{
 private FileStream _file;
 private static long _position = 0;
 private static object _lock = new object();
 string path = @"c:\temp";
 public void Init(HttpApplication application)
 {
  // alter Weg:
  //application.AddOnPreRequestHandlerExecuteAsync(
  //    new BeginEventHandler(BeginPreRequestHandlerExecute),
  //    new EndEventHandler(EndPreRequestHandlerExecute)
  //);

  // neuer Weg ab .NET 4.5
  EventHandlerTaskAsyncHelper helper = new EventHandlerTaskAsyncHelper(OnPreRequestHandlerExecute);
  application.AddOnBeginRequestAsync(helper.BeginEventHandler, helper.EndEventHandler);
 }

 public void Dispose() { }

 // ------------------------------- Alter Weg

 IAsyncResult BeginPreRequestHandlerExecute(Object source,
     EventArgs e, AsyncCallback cb, Object state)
 {
  HttpApplication app = (HttpApplication)source;
  DateTime time = DateTime.Now;

   var s = app.Request.GetBufferedInputStream();

  byte[] bytes = new byte[s.Length];
  int numBytesToRead = (int)s.Length;
  int numBytesRead = 0;
  while (numBytesToRead > 0)
  {
   // Read may return anything from 0 to numBytesToRead.
   int n = s.Read(bytes, numBytesRead, numBytesToRead);
   // The end of the file is reached.
   if (n == 0)
    break;
   numBytesRead += n;
   numBytesToRead -= n;
  }
  s.Close();

  count = count + 1;
  using (FileStream writer = new FileStream(
     path + "/RequestASync_" + DateTime.Now.ToLongTimeString().Replace(":", "") + "_" + count + ".txt", FileMode.Append))
  {
   writer.Write(bytes, 0, bytes.Length);
   writer.Flush();
   writer.Close();
  }


  string line = String.Format(
        "{0,6} {1,10:d}    {2,11:T}    {3, 32} {4,10}  {5}  ",
        count, time, time,
        app.Request.UserHostAddress, s.Length,
        app.Request.Url);

  byte[] output = Encoding.ASCII.GetBytes(line + System.Environment.NewLine);

  lock (_lock)
  {
   _file = new FileStream(
       HttpContext.Current.Server.MapPath(
           "~/App_Data/log/RequestLog_Async_Alt.txt"),
       FileMode.Append, FileAccess.Write,
       FileShare.Write, 1024, true);

   _position += output.Length;
   return _file.BeginWrite(output, 0, output.Length, cb, state);
  }
 }

 void EndPreRequestHandlerExecute(IAsyncResult ar)
 {
  _file.EndWrite(ar);
  _file.Close();
 }


 // ------------------------------- Neuer Weg

 public static int count = 0;
 private async Task OnPreRequestHandlerExecute(Object sender, EventArgs e)
 {
  HttpApplication app = (HttpApplication)sender;
  DateTime time = DateTime.Now;

  var s = app.Request.GetBufferedInputStream();

  byte[] bytes = new byte[s.Length];
  int numBytesToRead = (int)s.Length;
  int numBytesRead = 0;
  while (numBytesToRead > 0)
  {
   // Read may return anything from 0 to numBytesToRead.
   int n = await s.ReadAsync(bytes, numBytesRead, numBytesToRead);
   // The end of the file is reached.
   if (n == 0)
    break;
   numBytesRead += n;
   numBytesToRead -= n;
  }
  s.Close();

  count = count + 1;
  using (FileStream writer = new FileStream(
     path +"/RequestASync_" + DateTime.Now.ToLongTimeString().Replace(":", "") + "_" + count + ".txt", FileMode.Append))
  {
   await writer.WriteAsync(bytes, 0, bytes.Length);
   await writer.FlushAsync();
   writer.Close();
  }

  using (StreamWriter writer = new StreamWriter(
    app.Server.MapPath("~/App_Data/log/RequestLog_Async_Neu.txt"), true))
  {
   string line = String.Format(
       "{0,6} {1,10:d}    {2,11:T}    {3, 32} {4,10}  {5}  ",
       count, time, time,
       app.Request.UserHostAddress,s.Length,
       app.Request.Url
       );
   await writer.WriteLineAsync(line);
  }
 }
}
