﻿using System;
using System.Web;
using System.IO;

public class RequestLogModule : IHttpModule
{
 public void Init(HttpApplication application)
 {
  application.PreRequestHandlerExecute +=
      new EventHandler(OnPreRequestHandlerExecute); 
 }

 public void Dispose() { }

  public static int count = 0;
 void OnPreRequestHandlerExecute(Object sender, EventArgs e)
 {
  HttpApplication app = (HttpApplication)sender;
  DateTime time = DateTime.Now;


  var s = app.Request.GetBufferedInputStream(); // neu, besser: GetBufferedInputStream alt: GetBufferlessInputStream

  byte[] bytes = new byte[s.Length];
  int numBytesToRead = (int)s.Length;
  int numBytesRead = 0;
  while (numBytesToRead > 0)
  {
   // Read may return anything from 0 to numBytesToRead.
   int n = s.Read(bytes, numBytesRead, numBytesToRead);
   // The end of the file is reached.
   if (n == 0)
    break;
   numBytesRead += n;
   numBytesToRead -= n;
  }
  s.Close();

  count = count + 1;
  using (FileStream writer = new FileStream(
     app.Server.MapPath("~/App_Data/RequestSync_" + DateTime.Now.ToLongTimeString().Replace(":","") + "_" + count +".txt"), FileMode.Append))
  {
   writer.Write(bytes, 0, bytes.Length);
   writer.Flush();
   writer.Close();
  }


  using (StreamWriter writer = new StreamWriter(
    app.Server.MapPath("~/App_Data/RequestLog_Sync.txt"), true))
  {
   string line = String.Format(
       "{0,10:d}    {1,11:T}    {2, 32} {4,10}  {3}  ",
       time, time,
       app.Request.UserHostAddress,
       app.Request.Url, s.Length
       );
   writer.WriteLine(line);
  }

 }
}
