﻿<%@ WebHandler Language="C#" Class="chat.ChatHttpHandler" %>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.Web.WebSockets;

namespace chat
{

 public class ChatHttpHandler : IHttpHandler
 {

  public void ProcessRequest(HttpContext context)
  {

   if (HttpContext.Current.Application["count"] == null) HttpContext.Current.Application["count"] = 0;
   HttpContext.Current.Application["count"] = (int)HttpContext.Current.Application["count"] + 1;
   string user = "User#" + HttpContext.Current.Application["count"];
   if (context.Request.Cookies["username"] != null)
   {
    user = context.Request.Cookies["username"].Value;
   }


   if (context.IsWebSocketRequest)
   {
    context.AcceptWebSocketRequest(new ChatWebSocketHandler(user));
   }

  }

  public bool IsReusable
  {
   get
   {
    return false;
   }
  }
 }


 public class ChatWebSocketHandler : WebSocketHandler
 {
  private string user;
  private System.Web.Script.Serialization.JavaScriptSerializer serializer = new System.Web.Script.Serialization.JavaScriptSerializer();

  private static WebSocketCollection chatapp = new WebSocketCollection();

  public ChatWebSocketHandler(string username)
  {
   user = username;
  }

  public override void OnOpen()
  {
   chatapp.Add(this);

   chatapp.Broadcast(serializer.Serialize(new
   {
    type = MessageType.Join,
    from = user,
    value = user + " hat den Chat betreten!",
    otherData = "xxyy",
    Veranstaltung = "BASTA"
   }));

  }

  public override void OnMessage(string message)
  {
   var m = serializer.Deserialize<Message>(message);

   switch (m.Type)
   {
    case MessageType.Broadcast:
     chatapp.Broadcast(serializer.Serialize(new
     {
      type = m.Type,
      from = user,
      value = m.Value
     }));

     break;
    default:
     return;
   }
  }

  public override void OnClose()
  {
   chatapp.Remove(this);

   chatapp.Broadcast(serializer.Serialize(new
   {
    type = MessageType.Leave,
    from = user,
    value = user + " hat den Chat verlassen."
   }));
  }

  enum MessageType
  {
   Send,
   Broadcast,
   Join,
   Leave
  }

  class Message
  {
   public MessageType Type { get; set; }
   public string Value { get; set; }
  }

 }
}