﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using de.ITVisions.Validation;
using de.WWWings.GO.Validierungsannotationen;

namespace de.WWWings.GO
{

 




 /// <summary>
 /// Erweiterung der vom Entity Framework generierten Klassen "Flug"
 /// </summary>
 [System.ComponentModel.DataAnnotations.MetadataType(typeof(FlugMeta))]
 public partial class Flug
 {
  partial void OnFreiePlaetzeChanging(short? value)
  {
   //if (value.Value > this.Plaetze) throw new ValidationException("Freie Plätze müssen kleiner sein als Gesamtanzahl der Plätze. Freie Plätze= " + value.Value + " Plätze= " + this.Plaetze);
  }

  public override string ToString()
  {
   return "Flug " + this.FlugNr + " fliegt von " + this.Abflugort + " nach " + this.Zielort + " und hat " + this.FreiePlaetze + "!";
  }
 }


 /// <summary>
 /// Metadaten-Klasse für "Flug"
 /// </summary>
 //[ExpressionValidation("FreiePlaetze != null && FreiePlaetze >= 0 && Plaetze >= 10 && Plaetze <= 250 && FreiePlaetze <= Plaetze", ErrorMessage = "Platzkapaität ist zwischen 10 und 250 Plätzen. Freie Plätze müssen > 0 und <= Plätze sein.")] 
 public partial class FlugMeta
 {

  [Required]
  [RegularExpression("[A-Z][a-z]+[-/]?[A-Z]{0,1}[a-z]*", ErrorMessage = "Aufbau für Abflugort muss sein: Essen oder Essen-Muelheim oder Essen/Muelheim")]
  [StringLength(30, MinimumLength = 3)]
  [Choice("Rom", "Berlin", "Moskau", "Essen-Muelheim",ErrorMessage="Nicht erlaubter Ort")]
  public object Abflugort;

  [Required]
  [FlughafenName("Aufbau muss für Zielort sein: Essen oder Essen-Muelheim oder Essen/Muelheim")]
  [StringLength(30, MinimumLength = 3)]
  public object Zielort;

  [Required]
  [Display(Prompt = "Flugdatum")]
  [DisplayFormat(DataFormatString = "{0:dd.MM.yyyy HH:mm}")]
  public object Datum { get; set; }

  [Range(0, 250, ErrorMessage = "{0} muss zwischen {1} und {2} liegen!")]
  public int Plaetze { get; set; }


  [Range(0, 250, ErrorMessage = "{0} muss zwischen {1} und {2} liegen!")]
  public Nullable<int> FreiePlaetze { get; set; }

  //[Choice("Airbus","Boing","Canadair","Concorde","Dornier","Embraer","Fokker","Iljuschin","Pilatus","Saab")]
  //public string Flugzeug;
 }



 /// <summary>
 /// Annotierte Modelklasse "Flug"
 /// </summary>
 public partial class Flug2
 {
  [Required]
  public int FlugNr { get; set; }

  [Required]
  [RegularExpression("[A-Z][a-z]+[-/]?[A-Z]{0,1}[a-z]*", ErrorMessage = "Aufbau muss sein: Essen oder Essen-Muehlheim oder Essen/muehlheim")]
  [StringLength(30, MinimumLength = 3)]
  public string Abflugort { get; set; }

  [Required]
  [RegularExpression("[A-Z][a-z]+[-/]?[A-Z]{0,1}[a-z]*", ErrorMessage = "Aufbau muss sein: Essen oder Essen-Muehlheim oder Essen/muehlheim")]
  [StringLength(30, MinimumLength = 3)]
  public string Zielort { get; set; }

  [Required]
  public DateTime Datum { get; set; }

  [Range(0, 250, ErrorMessage = "{0} muss zwischen {1} und {2} liegen!")]
  public int Plaetze { get; set; }

  [Range(0, 250, ErrorMessage = "{0} muss zwischen {1} und {2} liegen!")]
  public int FreiePlaetze { get; set; }
 }
}
