﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using de.WWWings.GO;

namespace de.WWWings.GL
{

 /// <summary>
 /// Verwalten von Buchungen
 /// </summary>
 public partial class BuchungsManager
 {

  public IFlugBLManager flugBLManager = new FlugBLManager();

  public BuchungsManager(IFlugBLManager flugBLManager)
  {
   this.flugBLManager = flugBLManager;
  }


  /// <summary>
  /// Erstellen einer Buchung
  /// </summary>
  public bool BuchungenErstellen(int FlugNr, int PersonID)
  {
   Flug f = flugBLManager.GetFlug(FlugNr);
   modell.AttachTo("Flug", f);

   if (f == null) return false;
   Passagier p = modell.Person.OfType<Passagier>().Where(x => x.PersonID == PersonID).SingleOrDefault();
   if (p == null) return false;

   if (f.Passagier.Contains(p)) return false;

   f.Passagier.Add(p);
   modell.SaveChanges();
   return true;
  }


 }
}
