﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace Konsole45.FCL
{
 class CallerInfo
 {
  public void Run()
  {
   var Ergebnis = Berechnung(10);
   Console.WriteLine("Berechnungsergebnis: " + Ergebnis);
   Run2();
  }

  public void Run2()
  {
   var Ergebnis = Berechnung(12);
   Console.WriteLine("Berechnungsergebnis: " + Ergebnis);
  }

  public int Berechnung(int Wert,
        [CallerMemberName] string memberName = "",
        [CallerFilePath] string filePath = "",
        [CallerLineNumber] int lineNumber = 0)
  {
   // Ausgabe hier zu Anschauungszwecken an der Konsole
   Console.ForegroundColor = ConsoleColor.Yellow;
   Console.WriteLine("Routine Berechnung wurde aufgerufen!");
   Console.WriteLine("Aus diesem Quellcodepfad: " + filePath);
   Console.WriteLine("Von diesem Mitglied: " + memberName);
   Console.WriteLine("In dieser Zeilennummer: " + lineNumber);
   Console.ForegroundColor = ConsoleColor.Gray;
   // Eigentlicher Inhalt der Berechnung
   Console.WriteLine("Hier tue ich was...");
   return 10 * Wert;
  }


  //  Console.ForegroundColor = ConsoleColor.Green;

  //Console.WriteLine("----------------------------------");
  //System.Diagnostics.StackTrace t = new System.Diagnostics.StackTrace();
  //foreach (var f in t.GetFrames())
  //{
  // Console.WriteLine(f);
  //}


  public void Run3()
  {
   var d = new Datenobjekt();
   d.PropertyChanged += delegate { Console.WriteLine("Wert geändert!"); };
   d.Wert = 10;

  }
 }

 class Datenobjekt : System.ComponentModel.INotifyPropertyChanged
 {
  public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

  /// <summary>
  /// Realisierung in .NET 4.5 ohne dass der Aufrufer den Property-Namen übergeben muss
  /// </summary>
  /// <param name="propertyName"></param>
  private void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
  {
   if (PropertyChanged != null)
   {
    PropertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
   }
  }

  private int wert;

  public int Wert
  {
   get { return wert; }
   set { wert = value; NotifyPropertyChanged(); }
  }
 }
}
