﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Konsole45.FCL
{
 class DefaultThreadCultureDemo
 {

  public void run()
  {
   // Kultur definieren
   CultureInfo culture = CultureInfo.CreateSpecificCulture("en-US");

   // bisher schon: Kultur für aktuellen Thread setzen
   Thread.CurrentThread.CurrentCulture = culture;
   Thread.CurrentThread.CurrentUICulture = culture;

   // bisher schon: Kultur für kommende Thread setzen
   CultureInfo.DefaultThreadCurrentCulture = culture;
   CultureInfo.DefaultThreadCurrentUICulture = culture;

   // Ausgabe in diesem Thread
   Ausgabe();

   // Ausgabe im neuen Thread
   Task.Factory.StartNew(() => Ausgabe());
  }

  public string Ausgabe()
  {
   Console.WriteLine("Current Culture: " + Thread.CurrentThread.CurrentCulture);
   Console.WriteLine("Current UI Culture: " + Thread.CurrentThread.CurrentUICulture);
   Console.WriteLine(DateTime.Now);
   return "";
  }
 }
}
