﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AsyncIOSamples
{
 class AsyncIOSamples2
 {
  public static void run()
  {
   ProcessFilesAsync();
   //Main thread is not blocked during the read/write operations in the above method
   Console.WriteLine("Do something else in the main thread mean while!!!");
   Console.ReadLine();
  }
  private static async Task ProcessFilesAsync()
  {
   List<string> fileList = new List<string>()
      {
      @"h:\temp\DataFlatFile1.txt",
      @"h:\temp\DataFlatFile2.txt"
      };
   foreach (var fileName in fileList)
   {
    Console.WriteLine(fileName);
    //WriteFileAsync("xxx", fileName);
    string content = await ReadFileAsync(fileName);
   }
  }
  private static async void WriteFileAsync(string content, string outputFileName)
  {
   using (StreamWriter writer = new StreamWriter(outputFileName))
   {
    await writer.WriteAsync(content);
   }
  }
  private static async Task<string> ReadFileAsync(string fileName)
  {
   using (StreamReader reader = new StreamReader(fileName))
   {
    return await reader.ReadToEndAsync();
   }
  }
 }
}


namespace Konsole45.FCL
{
 class IODemo
 {

  public static void Run()
  {
   Console.WriteLine("Starte... Thread=" + System.Threading.Thread.CurrentThread.ManagedThreadId);
   ReadAsync();
   Console.WriteLine("Warte... Thread=" + System.Threading.Thread.CurrentThread.ManagedThreadId);
   while (true) { Console.Write("."); System.Threading.Thread.Sleep(100); }
  }

  /// <summary>
  /// Diese Methode startet das asynchrone Lesen
  /// </summary>
  /// <returns></returns>
  public async static Task<string> ReadAsync()
  {
   string path = @"w:\tatort.wtv";
   string inhalt = "";
   using (var sr = new System.IO.StreamReader(path))
   {
    inhalt = await sr.ReadToEndAsync(); // Hier wird die Kontrolle an den Arufrufer gegeben
    // das Lesen erfolgt in eigenem Thread
   }
   // Der Rest der Methode wird auch in eigenem Thread abgearbeitet
   Console.WriteLine("ReadAsync(): Thread=" + System.Threading.Thread.CurrentThread.ManagedThreadId);
   Console.WriteLine("ReadAsync(): Länge des Inhalts=" + inhalt.Length);
   return inhalt;
  }

  public async static Task<int> WriteAsync()
  {

   string path = @"h:\temp\daten.txt";

   using (var sw = new System.IO.StreamWriter(path, true))
   {
    Console.WriteLine("WriteAsync: Thread: " + System.Threading.Thread.CurrentThread.ManagedThreadId);
    for (int i = 0; i < 100; i++)
    {
     Console.WriteLine("WriteAsync: Thread: " + System.Threading.Thread.CurrentThread.ManagedThreadId);
     await sw.WriteLineAsync(i.ToString());
    }
    Console.WriteLine("WriteAsync: Thread: " + System.Threading.Thread.CurrentThread.ManagedThreadId);
   }

   return 100;

  }


 }
}
