﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Konsole45.FCL
{
 class MyWC : System.Net.WebClient
 {

 }

 class NetworkDemo
 {

  public async static void Run()
  {
   Stopwatch sw = new Stopwatch();
   sw.Start();
   Console.WriteLine("Run() #1: Thread=" + System.Threading.Thread.CurrentThread.ManagedThreadId);
   //await GetAsyncWebClient();
   await GetAsyncHttpClient();
   Console.WriteLine("Run() #2: Thread=" + System.Threading.Thread.CurrentThread.ManagedThreadId);
   sw.Stop();
   Console.WriteLine(sw.ElapsedMilliseconds);
  }

  /// <summary>
  ///  Diese Methode startet das asynchrone Herunterladen
  /// </summary>
  /// <returns></returns>
  public async static Task<string> GetAsyncWebClient()
  {
   List<string> urls = new List<string>() { "http://www.IT-Visions.de", "http://www.dotnetframework.de", "http://www.winrt.de", "http://www.dotnet-akademie.de" };
   string inhalt = "";
   using (var wc = new System.Net.WebClient())
   {
    foreach (string url in urls)
    {
     for (int i = 0; i < 10; i++)
     {
      inhalt = await wc.DownloadStringTaskAsync(url); // Hier wird die Kontrolle an den Arufrufer gegeben
      // Download erfolgt in eigenem Thread
      // Der Rest der Methode wird auch in eigenem Thread abgearbeitet
      Console.WriteLine("GetAsync(): Thread=" + System.Threading.Thread.CurrentThread.ManagedThreadId);
      Console.WriteLine("GetAsync(): Länge des Inhalts von " + url + "=" + inhalt.Length);
     }

    }
   }
   return inhalt;
  }


  /// <summary>
  /// Diese Methode startet das asynchrone Herunterladen
  /// </summary>
  /// <returns></returns>
  public async static Task<string> GetAsyncHttpClient()
  {
   List<string> urls = new List<string>() { "http://www.IT-Visions.de", "http://www.dotnetframework.de", "http://www.winrt.de", "http://www.dotnet-akademie.de" };
   string inhalt = "";
   using (var wc = new System.Net.Http.HttpClient())
   {
    foreach (string url in urls)
    {
     for (int i = 0; i < 10000; i++)
     {
      inhalt = await wc.GetStringAsync(url); // Hier wird die Kontrolle an den Arufrufer gegeben
      // Download erfolgt in eigenem Thread
      // Der Rest der Methode wird auch in eigenem Thread abgearbeitet
      Console.WriteLine("GetAsync(): Thread=" + System.Threading.Thread.CurrentThread.ManagedThreadId);
      Console.WriteLine("GetAsync(): Länge des " + i + ". Inhalts von " + url + "=" + inhalt.Length);
     }

    }
   }
   return inhalt;
  }
 }
}
