﻿using System;
using System.Collections.Generic;
using System.IO;
using System.IO.Compression;
using System.Linq;

namespace Konsole45.FCL
{
 class ZIPDemo
 {
    /// <summary>
  /// Packen einer ZIP-Datei
  /// </summary>
  public static void Run()
  {
   Console.WriteLine("Erstelle ZIP-Datei...");
   ZipFile.CreateFromDirectory(@"w:\documents", @"w:\documents-Archiv.zip", CompressionLevel.Optimal, true);
   Console.WriteLine("Entpacke ZIP-Datei...");
   ZipFile.ExtractToDirectory(@"w:\documents-Archiv.zip", @"w:\documents-archiv");
  }

  /// <summary>
  /// Packen einer ZIP-Datei
  /// </summary>
  public static void RunZip()
  {
   string ZipDateiPfad = @"c";
   Console.WriteLine("Erstelle ZIP-Datei " + ZipDateiPfad);
   if (System.IO.File.Exists(ZipDateiPfad)) System.IO.File.Delete(ZipDateiPfad);

   IEnumerable<string> files =
     Directory.EnumerateFiles(@"w:\documents", "*.docx");
   using (ZipArchive zipArchive =
     ZipFile.Open(@ZipDateiPfad, ZipArchiveMode.Create))
   {
    foreach (string file in files)
    {
     var eintragName = Path.Combine("Dokumente", Path.GetFileName(file));
     zipArchive.CreateEntryFromFile(file, eintragName);
    }
   }
   Console.WriteLine(files.Count() + " Dateien archiviert!");
  }


  /// <summary>
  /// Entpacken einer ZIP-Datei
  /// </summary>
  public static void RunUnzip()
  {
   string ZipDateiPfad = @"w:\documents.zip";
   Console.WriteLine("Entpacke ZIP-Datei " + ZipDateiPfad);

   using (ZipArchive zipArchive =
    ZipFile.Open(ZipDateiPfad, ZipArchiveMode.Read))
   {
    foreach (ZipArchiveEntry entry in zipArchive.Entries)
    {
     if (entry.Length < 10000)
     {
      using (Stream eingabe = entry.Open())
      {
       Console.WriteLine(entry.Name);
       var ausgabe = File.Create(@"w:\documents\entpackt_" + entry.Name);
       eingabe.CopyTo(ausgabe);
       ausgabe.Close();
      }
     }
    }
   }
  }
 }
}
