﻿using System;

namespace Modell
{
    public class Person : ModelBase
    {
        private string _name;
        private int _id;
        private int _age;

        public int Id
        {
            get { return _id; }
            set { _id = value; this.OnPropertyChanged("Id"); }
        }

        public string Name
        {
            get { return _name; }
            set { _name = value; this.OnPropertyChanged("Name"); }
        }

        public int Age
        {
            get { return _age; }
            set { _age = value; this.OnPropertyChanged("Age"); }
        }

        protected override string ValidateProperty(string propertyName)
        {
            switch (propertyName)
            {
                case "Name":
                    if (string.IsNullOrEmpty(this.Name))
                        return "Name is a mandatory field.";
                    break;
                case "Id":
                    if (this.Id <= 0)
                        return "ID must be greater than zero.";
                    break;
            }
            return null;
        }
    }
}
