using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;

namespace de.WWWings.Dienste
{

 /// <summary>
 /// WCF-Dienst fr Flugplan. PerCall == Zustandlosigkeit
 /// </summary>
 [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerSession)] // PerCall! oder zum Demo: PerSession
 public class FlugplanService : IFlugplanService
 {
  int calls = 0;
  static int instanzen = 0;
  string ClientInfo = "";
  public FlugplanService()
  {
   instanzen++;
   // Ausgaben nur zu Testzwecken!!!
   //string ausgabe = "Instanz #" + instanzen + " des Dienstes FlugplanService";
   //if (OperationContext.Current != null) ausgabe += ": " + OperationContext.Current.Channel.LocalAddress.ToString();
   //Console.WriteLine(ausgabe);
  }

  public string GetZustand()
  {
   string s = GetZustandIntern();
   return s;
  }

  private string GetZustandIntern()
  {
   string s = "PID=" + System.Diagnostics.Process.GetCurrentProcess().Id + " - Instanz=" + instanzen + " - Aufrufe=" + calls + (this.ClientInfo != "" ? " (" + this.ClientInfo + ")" : "");
   Console.WriteLine(s);
   return s;
  }

  public void SetZustand(string s)
  {
   calls++;
   //Console.WriteLine("SetZustand: " + s);
   this.ClientInfo = s;
   GetZustandIntern();

  }

  public de.WWWings.Flug HoleFlug(long FlugNr)
  {
   calls++;
   string s = "PID=" + System.Diagnostics.Process.GetCurrentProcess().Id + " - Instanz=" + instanzen + " - Aufrufe=" + calls;
   System.Console.WriteLine("GetFlug wird aufgerufen mit Nr " + FlugNr + ": " + s);
   var flug = de.WWWings.FlugBLManager.HoleFlug(FlugNr);
   flug.AbflugOrt = s;
   return flug;
  }

  //public de.WWWings.GO.Flug HoleFlug_EF(long FlugNr)
  //{
  // System.Console.WriteLine("HoleFlug_EF wird aufgerufen mit Nr " + FlugNr);
  // return new de.WWWings.GL.EF.FlugBLManager().GetFlug(FlugNr);
  //}


  public de.WWWings.FlugMenge HoleAlle()
  {
   calls++;
   return de.WWWings.FlugBLManager.HoleAlle(100, 0);
  }

  public de.WWWings.FlugMenge HoleAlleRoute(string von, string nach)
  {
   calls++;
   return de.WWWings.FlugBLManager.HoleAlle(von, nach);
  }
 }
}
