using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;

using de.WWWings.GO;

namespace de.WWWings.Dienste
{

 /// <summary>
 /// WCF-Dienst fr Flugplan. PerCall == Zustandlosigkeit
 /// </summary>
 [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall)]
 public class FlugplanServiceEF : de.WWWings.Vertraege.IFlugplanServiceEF
 {
  de.WWWings.GL.FlugBLManager bl = new de.WWWings.GL.FlugBLManager(false); // false = ohne Lazy Loading!

  public FlugplanServiceEF()
  {
   // Ausgaben nur zu Testzwecken!!!
   Console.WriteLine("Neue Instanz der Fassade FlugplanServiceEF!");
  }


  public List<de.WWWings.GO.Flug> GetFluegeVonOrt_Paging(string Ort, string Sortierung, int PagingAnzahl, int PagingStart)
  {
   return bl.GetFluegeVonOrt_Paging(Ort, Sortierung, PagingAnzahl, PagingStart);
  }

  public List<de.WWWings.GO.Flug> GetFluegeRoute(string Abflugort, string Zielort)
  {
   return bl.GetFluegeRoute(Abflugort, Zielort);
  }

  public de.WWWings.GO.Flug GetFlug(long FlugNr)
  {
   System.Console.WriteLine("HoleFlug_EF wird aufgerufen mit Nr " + FlugNr);
   return bl.GetFlug(FlugNr);
  }


  public long CountFluege()
  {
   return bl.CountFluege();
  }

  public long CountFluegeVonOrt(string Ort)
  {
   return bl.CountFluegeVonOrt(Ort);
  }

  public long CountFluegeRoute(string Abflugort, string Zielort)
  {
   return bl.CountFluegeRoute(Abflugort,  Zielort);
  }

  public List<de.WWWings.GO.Flug> GetFluege()
  {
   return bl.GetFluege();
  }

  public List<de.WWWings.GO.Flug> GetFluege_Paging(string Sortierung, int PagingAnzahl, int PagingStart)
  {
   return bl.GetFluege_Paging(Sortierung, PagingAnzahl, PagingStart);
  }

  public List<de.WWWings.GO.Flug> GetFluegeVonOrt(string ort)
  {
   return bl.GetFluegeVonOrt(ort);
  }


  public bool SaveFlug(de.WWWings.GO.Flug flug)
  {
   return true; // TODO: bl.SaveFlug(flug);
  }

  public de.WWWings.GO.Flug AddFlug(de.WWWings.GO.Flug flug)
  {
   return null; 

   // TODO:
   //bl.MarkFlugForAdding(flug);
   //bl.SaveFlug(flug);
   //return flug;
  }

  public void DeleteFlug(de.WWWings.GO.Flug flug)
  {
   bl.MarkFlugForDeletion(flug);
   bl.SaveFluege();
  }

  public string SaveFluege(List<de.WWWings.GO.Flug> fluege)
  {
   return ""; // TODO: bl.SaveFluege(fluege);
  }
 }
}
