﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.Runtime.Serialization;

namespace de.WWWings.WCFServices
{

 [DataContract]
 public class Kunde
 {
  [DataMember(EmitDefaultValue = false)]
  public int ID { get; set; }
  [DataMember(EmitDefaultValue = false)]
  public string Name { get; set; }
  [DataMember(EmitDefaultValue = false)]
  public string Ort { get; set; }
  [DataMember(EmitDefaultValue = false)]
  public string Strasse { get; set; }
  [DataMember(EmitDefaultValue = false)]
  public string Land { get; set; }
  [DataMember(EmitDefaultValue = false)]
  public string Galaxie { get; set; }
  [DataMember(EmitDefaultValue = false)]
  public DateTime Gründung { get; set; }
  [DataMember(EmitDefaultValue = false)]
  public Uri Website { get; set; }
  [DataMember(EmitDefaultValue = false)]
  public Version Version { get; set; }
  [DataMember(EmitDefaultValue = false)]
  public long Mitarbeiteranzahl { get; set; }
  [DataMember(EmitDefaultValue = false)]
  public double Umsatz { get; set; }

  [DataMember(EmitDefaultValue = false)]
  public Guid Guid { get; set; }
  //[DataMember(EmitDefaultValue = true)]
  private Guid Guid2 { get; set; }
 }


 [ServiceContract]
 class SerialisierungsDemoService
 {
  [OperationContract]
  public bool ErzeugeFehler(bool JaNein)
  {
   if (JaNein) throw new ApplicationException("Ungültige Parameter");
   return JaNein;
  }

  [OperationContract]
  public Stack<Kunde> GetKundenStack()
  {
   return new Stack<Kunde>();
  }

  [OperationContract]
  public List<Kunde> GetKundenList()
  {
   var k = new Kunde() { ID = 1233, Name = "www.IT-Visions.de", Guid = Guid.NewGuid(), Version = new Version(1,2,3,4), Website=new Uri("http://www.dotnetframework.de"), Umsatz = 1234.56, Mitarbeiteranzahl = 20 };


   return new List<Kunde>() { k };
  }

  [OperationContract]
  public SortedDictionary<int, Kunde> GetAnsprechpartner()
  {
   return null;
  }

 }
}
