﻿using System.ComponentModel;
using System.ServiceModel;
using System.ServiceModel.Web;
namespace de.WWWings.Vertraege
{
 /// <summary>
 /// Dienstvertrag für einen REST-basierten WCF-Dienst
 /// </summary>
 [ServiceContract]
 public interface IFlugplanServiceREST
 {
  [OperationContract()]
  [Description("Diese Operation liefert Daten zu allen Flügen.")]
  [WebGet(UriTemplate = "AlleFluege")]
  de.WWWings.FlugMenge HoleAlle();

  [OperationContract()]
  [Description("Diese Operation liefert Daten zu allen Flügen einer Route.")]
  [WebGet(UriTemplate = "Route/{von}/{nach}", BodyStyle = WebMessageBodyStyle.Wrapped)]
  de.WWWings.FlugMenge HoleAlleRoute(string von, string nach);

  [OperationContract()]
  [Description("Diese Operation liefert Daten zu einem Flug.")]
  [WebGet(UriTemplate = "FlugNr/{FlugNr}", ResponseFormat = WebMessageFormat.Xml)]
  de.WWWings.Flug HoleFlug(string FlugNr);
 }
}
