using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace de.WWWings.Workflow.Aktivitaeten
{
	public partial class PlatzBuchen: Activity
	{

  /// <summary>
  /// Dependency Property
  /// </summary>
  public static DependencyProperty FlugNrProperty = DependencyProperty.Register("FlugNr", typeof(long), typeof(de.WWWings.Workflow.Aktivitaeten.PlatzBuchen));

  [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
  [BrowsableAttribute(true)]
  [CategoryAttribute("Geschftsdaten")]
  public long FlugNr
  {
   get
   {
    return ((long)(base.GetValue(de.WWWings.Workflow.Aktivitaeten.PlatzBuchen.FlugNrProperty)));
   }
   set
   {
    base.SetValue(de.WWWings.Workflow.Aktivitaeten.PlatzBuchen.FlugNrProperty, value);
   }
  }



  public static DependencyProperty PassagierNrProperty = System.Workflow.ComponentModel.DependencyProperty.Register("PassagierNr", typeof(long), typeof(PlatzBuchen));

  [Description("Passagiernummer als Zahl")]
  [Category("Geschftsdaten")]
  [Browsable(true)]
  [DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)]
  public long PassagierNr
  {
   get
   {
    return ((long)(base.GetValue(PlatzBuchen.PassagierNrProperty)));
   }
   set
   {
    base.SetValue(PlatzBuchen.PassagierNrProperty, value);
   }
  }






  private long _Buchungscode;

  public long Buchungscode
  {
   get { return _Buchungscode; }
   set { _Buchungscode = value; }
  }


  public PlatzBuchen()
		{
			InitializeComponent();
		}


  protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
  {
   de.WWWings.PassagierSystem.Passagier p;
   p = new de.WWWings.PassagierSystem.Passagier(PassagierNr);

   Trace(String.Format("Buche Pltze fr Passagier {0} auf auf Flug {0}...", p.GanzerName, this.FlugNr));
   long b = p.Buchen(this.FlugNr);
   this._Buchungscode = b;

   Trace("Buchung erfolgt. Buchungscode: " + b);

   return ActivityExecutionStatus.Closed;
  }




 


  #region Hilfsroutinen
  private void Trace(string s)
  {
   Console.ForegroundColor = ConsoleColor.Green;
   Console.Write("Workflow {0} in Thread {1}: ", this.WorkflowInstanceId, System.Threading.Thread.CurrentThread.ManagedThreadId);
   Console.ForegroundColor = ConsoleColor.White;
   Console.WriteLine(s);
   this.TrackData(s);
  }

  private void TraceError(string s)
  {
   Console.ForegroundColor = ConsoleColor.Red;
   Console.Write("Workflow {0} in Thread {1}: ", this.WorkflowInstanceId, System.Threading.Thread.CurrentThread.ManagedThreadId);
   Console.ForegroundColor = ConsoleColor.White;
   Console.WriteLine(s);
   this.TrackData(s);
  }

  #endregion
	}
}
