﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml.Linq;
using Microsoft.VisualStudio.Tools.Applications.Runtime;
using Office = Microsoft.Office.Core;
using Word = Microsoft.Office.Interop.Word;
using OfficeWord_AddIn;
using OfficeWord_Vorlage.WWWingsDienste;

namespace OfficeWord_Vorlage
{
 public partial class ThisDocument
 {
  private void ThisDocument_Startup(object sender, System.EventArgs e)
  {
    
   var tp = new TaskPane_Fluege();
   tp.FluegeGeladen += new EventHandler<FluegeGeladenEventArgs>(tp_FluegeGeladen);


   this.ActionsPane.Controls.Add(tp);

  }


  void tp_FluegeGeladen(object sender, FluegeGeladenEventArgs e)
  {

   this.C_Abflugort.Text = e.Abflugort;
   

   //Microsoft.Office.Interop.Word.Document doc = this.Application.ActiveDocument;
   string ausgabe = "";
   foreach (Flug f in e.Fluege)
   {
    ausgabe += ("Flug #" + f.flugNr + ": ");
    ausgabe += ("von " + f.abflugOrt + " nach " + f.zielOrt + "\n");
   }
   this.C_Flugliste.Text = ausgabe;

  }
  private void ThisDocument_Shutdown(object sender, System.EventArgs e)
  {
  }

  #region VSTO Designer generated code

  /// <summary>
  /// Required method for Designer support - do not modify
  /// the contents of this method with the code editor.
  /// </summary>
  private void InternalStartup()
  {
   this.C_ServerTest.Click += new System.EventHandler(this.C_ServerTest_Click);
   this.Shutdown += new System.EventHandler(this.ThisDocument_Shutdown);
   this.Startup += new System.EventHandler(this.ThisDocument_Startup);

  }

  #endregion

  private void C_ServerTest_Click(object sender, EventArgs e)
  {
   try
   {
    OfficeWord_Vorlage.WWWingsDienste.FlugplanServiceClient sv = new FlugplanServiceClient("Flugplanservice_" + "TCP");
    List<Flug> fluege = sv.HoleAlleRoute("Rom", "Rom");
    sv.Close();
    MessageBox.Show("Serververbindung OK!","Servertest");
   }
   catch (Exception ex)
   {
    MessageBox.Show("Serververbindung Fehler: " + ex.Message,"Servertest");
   }
  }
 }
}
