﻿using de.WWWings.GL;
using Microsoft.VisualStudio.TestTools.UnitTesting;

using System.Collections.Generic;

namespace WWWings_UnitTests
{


    public class DALMock : IFlugDataManager
    {

        #region IFlugDataManager Members

        public List<Flug> HoleAlle(string Ort)
        {
            // Problem: System.Data.SqlClient.SqlException kann man nicht instanziieren!
            throw new System.ApplicationException("SqlExeption");
        }

        public List<Flug> HoleAlle()
        {
            // Problem: System.Data.SqlClient.SqlException kann man nicht instanziieren!
            throw new System.ApplicationException("SqlExeption");
        }

        public Flug HoleFlug(long Nr)
        {
            // Problem: System.Data.SqlClient.SqlException kann man nicht instanziieren!
            throw new System.ApplicationException("SqlExeption");
        }

        #endregion
    }


    /// <summary>
    ///This is a test class for FlugBLManagerTest and is intended
    ///to contain all FlugBLManagerTest Unit Tests
    ///</summary>
    [TestClass()]
    public class FlugBLManagerTest_IoC
    {
    
        FlugBLManager_IoC BL;
        Flug f;

        [TestInitialize()]
        public void MyTestInitialize()
        {
            BL = new FlugBLManager_IoC();
            BL.DAL = new DALMock();

        }

        [TestMethod]
        [ExpectedException(typeof(System.ApplicationException), "Datenbank nicht verfügbar!")]
        public void Teste_HoleFlug()
        {
            f = BL.HoleFlug(101);
            Assert.AreEqual(f.FlugNr, 101);
        }

        [TestMethod]
        [ExpectedException(typeof(System.ApplicationException), "Datenbank nicht verfügbar!")]
        public void Teste_HoleAlle()
        {
            BL.HoleAlle();
        }


    }
}
