using de.WWWings.GL;
using Microsoft.VisualStudio.TestTools.UnitTesting;

using System.Collections.Generic;

namespace WWWings_UnitTests
{


 /// <summary>
 ///This is a test class for FlugBLManagerTest and is intended
 ///to contain all FlugBLManagerTest Unit Tests
 ///</summary>
 [TestClass()]
 public class FlugBLManagerTest_Prepared
 {


  private TestContext testContextInstance;

  /// <summary>
  ///Gets or sets the test context which provides
  ///information about and functionality for the current test run.
  ///</summary>
  public TestContext TestContext
  {
   get
   {
    return testContextInstance;
   }
   set
   {
    testContextInstance = value;
   }
  }

  #region Additional test attributes
  // 
  //You can use the following additional attributes as you write your tests:
  //
  //Use ClassInitialize to run code before running the first test in the class
  //[ClassInitialize()]
  //public static void MyClassInitialize(TestContext testContext)
  //{
  //}
  //
  //Use ClassCleanup to run code after all tests in a class have run
  //[ClassCleanup()]
  //public static void MyClassCleanup()
  //{
  //}
  //
  //Use TestInitialize to run code before running each test
  //[TestInitialize()]
  //public void MyTestInitialize()
  //{
  //}
  //
  //Use TestCleanup to run code after each test has run
  //[TestCleanup()]
  //public void MyTestCleanup()
  //{
  //}
  //
  #endregion


  /// <summary>
  /// Testet das holen eines einzelnes Flugs
  ///</summary>
  [TestMethod()]
  public void HoleFlugTest_GueltigeFlugnummer()
  {
   FlugBLManager target = new FlugBLManager();
   Flug actual;

   long Nr1 = 101;
   actual = target.HoleFlug(Nr1);
   Assert.AreEqual(actual.FlugNr, Nr1);
   Assert.AreEqual(actual.Abflugort, "Seattle");
   Assert.AreEqual(actual.Zielort, "Rom");
   Assert.AreEqual(actual.Plaetze, (short)250);


  }


  /// <summary>
  /// Testet das holen eines einzelnes Flugs
  ///</summary>
  [TestMethod()]
  //[ExpectedException(typeof(System.InvalidOperationException))] // Fr Demo. Dann muss die Implementierung von GetFlug auf Single() statt SingleOrDefault() lauten!
  public void HoleFlugTest_UngueltigeFlugnummerErzeugtFehler()
  {
   FlugBLManager target = new FlugBLManager();
   Flug actual;

   long Nr2 = 1; // ungltige Nummer!
   actual = target.HoleFlug(Nr2);
   Assert.IsNull(actual);
  }


  /// <summary>
  /// Testet das holen eines einzelnes Flugs
  ///</summary>
  //[TestMethod()]
  //public void HoleFlugTest_UngueltigeFlugnummerLiefertNull()
  //{
  // FlugBLManager target = new FlugBLManager();
  // Flug actual;

  // long Nr2 = 99;
  // actual = target.GetFlug(Nr2);
  // Assert.IsNull(actual);

  //}


  /// <summary>
  ///A test for GetFluegeVonOrt
  ///</summary>
  [TestMethod()]
  public void HoleAlleTest1()
  {
   FlugBLManager target = new FlugBLManager(); // TODO: Initialize to an appropriate value
   string Ort = "Rom"; // TODO: Initialize to an appropriate value
   List<Flug> expected = null; // TODO: Initialize to an appropriate value
   List<Flug> actual;
   actual = target.HoleAlle(Ort);
   Assert.IsTrue(actual.Count > 10);
  }

  /// <summary>
  ///A test for GetFluegeVonOrt
  ///</summary>
  [TestMethod()]
  public void HoleAlleTest()
  {
   List<Flug> actual;
   actual = new FlugBLManager().HoleAlle();
   Assert.IsTrue(actual.Count > 200);
   CollectionAssert.AllItemsAreUnique(actual);
   CollectionAssert.AllItemsAreNotNull(actual);
   CollectionAssert.AllItemsAreInstancesOfType(actual, typeof(Flug));


  }


 }
}
