﻿Imports WWWings_GL_DZS_CS
Imports WWWings35_BO
Imports WWWings35_BO.LTS

Module XMLLiterals

 Sub Main()

  Console.WriteLine("--- Start (VB) ")
  XML_Fluege_Select()
  Console.WriteLine("--- Ende ")
  Console.ReadLine()

  'XML_Fluege_Inline()
  'XML_Literal_Demo_Fragment()
  ''XML_Fluege_Convert()
  'Console.ReadLine()
 End Sub

 Sub XML_Literal_Demo_Fragment()

  ' Ein XML-Fragment kann man einfach definieren...

  Dim e As XElement = _
<Flug ID="347">
 <Abflugort>Madrid</Abflugort>
 <Zielort>Paris</Zielort>
 <FreiePlaetze>1</FreiePlaetze>
 <Details>
  <Nichtraucher>True</Nichtraucher>
  <Plaetze>250</Plaetze>
  <EingerichtetAm/>
 </Details>
</Flug>


  ' und  einfach verwenden:
  Console.WriteLine(e.@ID)
  Console.WriteLine(e.<Abflugort>.Value)
  Console.WriteLine(e.<Zielort>.Value)
  Console.WriteLine(e.<Details>.<Plaetze>.Value)

 End Sub

 Sub XML_Literal_Demo_Document()
  Dim d As XDocument = _
<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<Fluege>
 <Flug ID="347">
  <Abflugort>Madrid</Abflugort>
  <Zielort>Paris</Zielort>
  <FreiePlaetze>1</FreiePlaetze>
  <Details>
   <Nichtraucher>True</Nichtraucher>
   <Plaetze>250</Plaetze>
   <EingerichtetAm/>
  </Details>
 </Flug>
 <Flug ID="220">
  <Abflugort>Madrid</Abflugort>
  <Zielort>Paris</Zielort>
  <FreiePlaetze>1</FreiePlaetze>
  <Details>
   <Nichtraucher>True</Nichtraucher>
   <Plaetze>250</Plaetze>
   <EingerichtetAm/>
  </Details>
 </Flug>
</Fluege>

  Dim e2 As XElement = d.Document.Root
  Console.WriteLine(d.Document.Root.<Flug>(1).@ID) ' 220
 End Sub


 Sub XML_Fluege_Select()

  ' Natürlich kann man Dokumente laden...
  Dim doc = XDocument.Load("flugliste.xml")

  ' und LINQ einsetzen zum Abfragen
  Dim query = _
      From i In doc.<Fluege>.<Flug> _
      Where i.<FreiePlaetze>(0).Value > 100 _
      Select i

  For Each result In query

   Console.WriteLine(result.@ID.ToString() & "=" & _
                     result.<FreiePlaetze>.Value)
  Next
 End Sub

 Sub XML_Fluege_Convert()

  ' --- Einlesen aus Datenbank
  Dim db As New WWWingsDataContext
  Dim fluege As List(Of Flug)
  fluege = (From f In db.Flug Select f).ToList()
  Console.WriteLine(fluege.Count)

  ' --- Exportieren in XML
  Dim e As XElement = _
  <Fluege>
   <%= From f In fluege _
    Where f.Abflugort = "Rom" _
    Select <Flug id=<%= f.FlugNr %>>
            <AbflugOrt><%= f.Abflugort %></AbflugOrt>
            <ZielOrt><%= f.Zielort %></ZielOrt>
            <Plaetze><%= f.FreiePlaetze %></Plaetze>
           </Flug> %>
  </Fluege>
  e.Save("Flugdatenexport.xml")

  Console.WriteLine(e)

 End Sub

 Sub XML_Fluege_Inline()
  Dim doc = XDocument.Load("flugliste.xml")
  For Each result In doc.<Fluege>.<Flug>
   Console.WriteLine(result.@ID.ToString() & "=" & _
                     result.<FreiePlaetze>(0).Value)
  Next
 End Sub
 Sub XML_Counter_Select()
  Dim doc = XDocument.Load("counter.xml")

  Dim query = _
      From i In doc.<counter>.<url> _
      Where i.<count>(0).Value > 1 _
      Select i

  Console.WriteLine(query)

  For Each result In query
   Console.WriteLine(result.@name.ToString() & "=" & result.<count>(0).Value)
  Next
 End Sub

 Sub XML_Inline()
  Dim doc = XDocument.Load("counter.xml")

  For Each result In doc.<counter>.<url>
   Console.WriteLine(result.@name.ToString() & "=" & result.<count>(0).Value)
  Next
 End Sub
 Sub LINQ_Select()
  Dim db As New WWWingsDataContext

  Dim q = From f In db.Flug _
          Where f.Abflugort = "ROM" _
          Select f

  For Each flug In q
   Console.WriteLine(flug.Abflugort)
  Next
 End Sub
End Module
