﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Windows.Input;
using System.Collections.Generic;


using System.Data.Objects.DataClasses;
using WWWings_EF4_WPF;
using de.WWWings.GL;
using de.WWWings.GO;
namespace WWWings_WPF
{
 public partial class F_Flugbuchung
 {

  public static readonly DependencyProperty ZaehlerProperty = DependencyProperty.Register("Counter", typeof(int), typeof(F_Flugbuchung), new PropertyMetadata(0));
  public int Zaehler
  {
   get { return (int)GetValue(ZaehlerProperty); }
   set { SetValue(ZaehlerProperty, value); }
  }


  public static RoutedCommand BeendenBefehl = new RoutedCommand();

  public F_Flugbuchung()
  {
   this.InitializeComponent();
   // Tastaturkürzel definieren
   KeyGesture Taste = new KeyGesture(Key.B, ModifierKeys.Control);

   // Befehl definieren
   BeendenBefehl.InputGestures.Add(Taste);

   // Binding definieren
   CommandBinding cb = new System.Windows.Input.CommandBinding(BeendenBefehl);
   this.CommandBindings.Add(cb);
   cb.Executed += new System.Windows.Input.ExecutedRoutedEventHandler(cb_Executed);
   cb.CanExecute += new System.Windows.Input.CanExecuteRoutedEventHandler(cb_CanExecute);

   GetData();
  }

  de.WWWings.GL.PassagierBLManager passagierManager = new de.WWWings.GL.PassagierBLManager();
  de.WWWings.GL.FlugBLManager flugManager = new de.WWWings.GL.FlugBLManager();
  EntityCollection<de.WWWings.GO.Flug> Fluege;
  de.WWWings.GO.Passagier passagier;
  int PID = 2878;

  private void GetData()
  {

   // Datenbindung
  
   if (Int32.TryParse(C_PID.Text, out PID))
   {
    // Manuelle Datenbefüllung
    passagier = passagierManager.GetPassagier(PID);
    if (passagier == null)
    {
     MessageBox.Show("Passagier nicht gefunden!");
    }
    else
    {
     this.C_PName.Text = passagier.Name;
     HoleDatenFuerListBox(PID);

     MainWindow w = FindParentWindow(this) as MainWindow;
     if (w != null) w.LetztePersonen.Add(passagier.Person);
    }
   }
  }

  private void HoleDatenFuerListBox(int PID)
  {   if (this.C_Fluege == null) return;
   // Datenbindung für ListBox
   List<Flug> fluege = null;
   if ((this.C_Filter.SelectedValue == null) || (this.C_Filter.SelectedValue.ToString() == "Alle Flüge"))
    fluege = flugManager.GetFluegeMitStatusFuerPassagier(PID, BuchungsFilterStatus.Alle);
   if ((this.C_Filter.SelectedValue != null) || (this.C_Filter.SelectedValue.ToString() == "Nur gebuchte"))
    fluege = flugManager.GetFluegeMitStatusFuerPassagier(PID, BuchungsFilterStatus.NurGebuchte);
   if ((this.C_Filter.SelectedValue != null) || (this.C_Filter.SelectedValue.ToString() == "Nur nicht gebuchte"))
    fluege = flugManager.GetFluegeMitStatusFuerPassagier(PID, BuchungsFilterStatus.NurNichtGebuchte);
   this.C_Fluege.DataContext = fluege;
  }


  public static Window FindParentWindow(DependencyObject child)
  {
   DependencyObject parent = VisualTreeHelper.GetParent(child);

   //CHeck if this is the end of the tree 
   if (parent == null) return null;

   Window parentWindow = parent as Window;
   if (parentWindow != null)
   {
    return parentWindow;
   }
   else
   {
    //use recursion until it reaches a Window 
    return FindParentWindow(parent);
   }
  }


  void cb_CanExecute(object sender, System.Windows.Input.CanExecuteRoutedEventArgs e)
  {
   e.CanExecute = true;
  }

  void cb_Executed(object sender, System.Windows.Input.ExecutedRoutedEventArgs e)
  {
   // TODO: this.Close();
  }


  private void C_Buchen_Click(object sender, RoutedEventArgs e)
  {
   // TODO: Code schreiben!!!
   MessageBox.Show("Funktion noch nicht fertig!");
   HoleDatenFuerListBox(PID);
  }
  private void C_Ende_Click(object sender, RoutedEventArgs e)
  {
   // TODO: this.Close();
  }

  private void C_Suchen_Click(object sender, RoutedEventArgs e)
  {

   GetData();
  }


  private void Buchung()
  {
   // Animation manuell starten
   System.Windows.Media.Animation.Storyboard sb = (Storyboard)this.FindResource("C_DrehAnimation");
   //sb.Begin(this);
   //MessageBox.Show("Diese Funktion ist leider noch nicht implementiert!");
  }



  private void C_Flugverwaltung_Click(object sender, RoutedEventArgs e)
  {
   // TODO  new F_Flugverwaltung().ShowDialog();
  }


  private void C_Details_Click(object sender, RoutedEventArgs e)
  {
   Flug f = (Flug)this.C_Fluege.SelectedItem;
   MessageBox.Show("Details zu diesem Flug: " + f.ToString());
  }



  //private string GetContent(UIElement Element)
  //{
  // foreach(UIElement e in Element.
  //}

  private void Test()
  {
   //this.C_Fluege.
  }

  BuchungsManager buchungsManager = new BuchungsManager();
  private void C_Storno_Click(object sender, RoutedEventArgs e)
  {
   Flug f = (Flug)this.C_Fluege.SelectedItem;
   buchungsManager.BuchungenLoeschen(f.FlugNr, passagier.PersonID);
   MessageBox.Show("Flug wurde storniert: " + f.ToString());
   HoleDatenFuerListBox(PID);
  }

  private void ComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
  {
   HoleDatenFuerListBox(PID);
  }



 }
}