using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using de.WWWings.PassagierSystem;
using de.WWWings;

namespace WindowsUI.CallCenterApp
{
 public partial class F_Passagier : Form
 {
  public F_Passagier()
  {
   InitializeComponent();
   List<Passagier> pp = Dienste.PassagierverwaltungServiceClient.HoleAllePassagiere();
   this.passagierBindingSource.DataSource = pp;
  }

  private void F_Passagier_Load(object sender, EventArgs e)
  {


  }

  private void bindingNavigatorMovePreviousItem_Click(object sender, EventArgs e)
  {

  }

  private void bindingNavigatorMoveNextItem_Click(object sender, EventArgs e)
  {

  }

  /// <summary>
  /// Aktualisierung der Anzeige fr den aktuellen Datensatz
  /// </summary>
  private void Refresh()
  {
   // Liste leeren
   this.C_Fluege.Items.Clear();

   // Aktuelle Passagier ermitteln
   Passagier p = this.passagierBindingSource.Current as Passagier;

   // Liste neu befllen
   List<Buchung> bb = Dienste.BuchungsServiceClient.HoleBuchungenFuerPassagier(p.PID);
   foreach (Buchung b in bb)
   {
    foreach (Flug f in b.Fluege)
    {
     ListViewItem l = new ListViewItem(b.Buchungscode.ToString());
     l.Tag = b.Buchungscode.ToString();
     l.ImageIndex = 0;
     //ListViewItem.ListViewSubItem c = new ListViewItem.ListViewSubItem(l, b.buchungscode.ToString());
     ListViewItem.ListViewSubItem n = new ListViewItem.ListViewSubItem(l, f.FlugNr.ToString());
     ListViewItem.ListViewSubItem s = new ListViewItem.ListViewSubItem(l, f.AbflugOrt + "->" + f.ZielOrt);
     ListViewItem.ListViewSubItem d = new ListViewItem.ListViewSubItem(l, f.Datum.ToString());
     //l.SubItems.Add(c);
     l.SubItems.Add(n);
     l.SubItems.Add(s);
     l.SubItems.Add(d);
     this.C_Fluege.Items.Add(l);
    }
   }

  }

  /// <summary>
  /// Speichern des Datensatzes
  /// </summary>
  /// <param name="sender"></param>
  /// <param name="e"></param>
  private void passagierBindingNavigatorSaveItem_Click(object sender, EventArgs e)
  {
   Passagier p = this.passagierBindingSource.Current as Passagier;
   // TODO:    Dienste.PassagierverwaltungServiceClient

   this.C_Status.Text = "Passagier " + p.PID + " gespeichert!";
  }

  private void button2_Click(object sender, EventArgs e)
  {
   if (this.C_Fluege.CheckedItems.Count == 0)
   {
    MessageBox.Show("Sie mssen zuerst Buchungen auswhlen!", "Bedienungsfehler");
    return;
   }
   string ausgabe = "";
   // Schleife ber ausgewhlte Elemente
   foreach (ListViewItem l in this.C_Fluege.CheckedItems)
   {
    long BuchungsCode = Convert.ToInt64(l.Tag);
    Dienste.BuchungsServiceClient.BuchungenLoeschen(BuchungsCode);
    ausgabe += BuchungsCode.ToString() + " ";
   }
   this.C_Status.Text = "Buchungen gelscht: " + ausgabe;
   Refresh();
  }


  private void button3_Click(object sender, EventArgs e)
  {
   Passagier p = this.passagierBindingSource.Current as Passagier;
   Dienste.BuchungsServiceClient.AlleBuchungenLoeschenFuerPassagier(p.PID);
   this.C_Status.Text = "Alle Buchungen gelscht!";
   Refresh();
  }

  private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
  {
   switch (this.comboBox1.Text)
   {
    case "Liste": this.C_Fluege.View = View.List; break;
    case "Details": this.C_Fluege.View = View.Details; break;
    case "Symbole": this.C_Fluege.View = View.SmallIcon; break;
   }
  }

  private void C_TicketDruck_Click(object sender, EventArgs e)
  {

   if (this.C_Fluege.CheckedItems.Count != 1)
   {
    MessageBox.Show("Sie mssen bitte genau eine Buchungen auswhlen!", "Bedienungsfehler");
    return;
   }

   long BuchungsCode = Convert.ToInt64(this.C_Fluege.CheckedItems[0].Tag);

   Fensterverwaltung.Zeige_Ticketdruck(BuchungsCode);
  }



  private void C_Beenden_Click(object sender, EventArgs e)
  {
   this.Close();
  }

  private void button1_Click(object sender, EventArgs e)
  {

   // Aktuelle Passagier ermitteln
   Passagier p = this.passagierBindingSource.Current as Passagier;
   if (p == null)
   {
    MessageBox.Show("ngltiger Passagier!");
    return;
   }
   CallCenterApp.F_Buchung b = new F_Buchung();
   b.PID = p.PID;
   b.ShowDialog();

   // Anzeige aktualisieren
   Refresh();
  }

  private void passagierBindingSource_PositionChanged(object sender, EventArgs e)
  {
   Refresh();
  //System.Windows.Forms.MessageBox.Show("OK");
  }
 }
}