﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using de.WWWings.WCF;


namespace de.WWWings.ConsoleClient.WCFClientDemos
{


 /// <summary>
 /// Interaction logic for RouterClientForm.xaml
 /// </summary>
 public partial class RouterClientForm : Window
 {
  public RouterClientForm(List<Szenario> Szenarien)
  {
   this.Szenarien = Szenarien;
   InitializeComponent();
  }

  public List<Szenario> Szenarien { get; set; }

  private void Grid_Loaded(object sender, RoutedEventArgs e)
  {
   this.C_Szenarien.AutoGenerateColumns = true;
   this.C_Szenarien.ItemsSource = Szenarien;

  }

  private void C_Start_Click(object sender, RoutedEventArgs e)
  {

  }
  ObservableCollection<View> ErgebnisListe = new ObservableCollection<View>();
  private void C_Szenarien_MouseDoubleClick(object sender, MouseButtonEventArgs e)
  {
   var Szenario = (this.C_Szenarien.SelectedItem as Szenario);
   if (Szenario == null) return;
   // this.C_Ausgabe.Text = "";
   FlugplanServiceClient c = new FlugplanServiceClient(Szenario.Binding, new EndpointAddress(Szenario.URI));

   //if (System.Windows.Forms.MessageBox.Show("Möchten Sie das Szenario #" + Szenario.ID + " starten?", "Frage", System.Windows.Forms.MessageBoxButtons.YesNo) == System.Windows.Forms.DialogResult.No) return;

   Stopwatch sw = new Stopwatch();
   sw.Start();

   int FlugNrStart = 110;

   if (!String.IsNullOrEmpty(this.C_FlugNr.Text))
   {
    Int32.TryParse(this.C_FlugNr.Text, out FlugNrStart);
   }


   for (int i = FlugNrStart; i < FlugNrStart+10; i++) // 610 für Leistungstest
   {
    var Ergebnis = new View() { ID = i };


    using (OperationContextScope ocs = new OperationContextScope((c.InnerChannel)))
    {

     //Header setzen. Damit lassen sich die Custom-Filter beeinflussen und zu einer Auswahl zwingen!
     if (this.C_Alternierend.IsChecked.GetValueOrDefault())
     {
      if (i % 2 == 0)
      {
       MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;
       messageHeadersElement.Add(MessageHeader.CreateHeader("Ziel", "WWWings/SOAPHeader", 1));
      }
      else
      {
       MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;
       messageHeadersElement.Add(MessageHeader.CreateHeader("Ziel", "WWWings/SOAPHeader", 2));
      }
     }
     else
     {
      int Zahl;
      if (Int32.TryParse(this.C_CustomHeaderZahl.Text, out Zahl))
      {
       MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;
       messageHeadersElement.Add(MessageHeader.CreateHeader("Ziel", "WWWings/SOAPHeader", Zahl));
      }

     }
     // Aufruf

     try
     {
      if (this.C_OneWay.IsChecked.GetValueOrDefault())
      {
       //if (Szenario.ID != 5) { MessageBox.Show("Multicast nur mit Szenario 5 möglich!"); return; }
       c.SetZustand("Eingabe #" + i);
         Ergebnis.Spalte1 = "Eingabe #" + i;
      }
      else
      {
       Flug f = c.HoleFlug(i);

       Ergebnis.Spalte1 = "Flug " + f.FlugNr + " nach " + f.ZielOrt + ": " + f.FreiePlaetze + " Plätze.";
       Ergebnis.Spalte2 = f.AbflugOrt;

       //this.C_Ausgabe.Text += (f.FlugNr + " fliegt  nach " + f.ZielOrt + " und hat " + f.FreiePlaetze + " Plätze!") + "\n";
       //this.C_Ausgabe.Text += (f.AbflugOrt) + "\n";


       // string Zustand = c.GetZustand();
      }
     }
     catch (Exception ex)
     {
      Ergebnis.Spalte1 = ("!!! Fehler bei Abruf von " + i + ": " + ex.Message);
      //this.C_Ausgabe.Text += ("!!! Fehler bei Abruf von " + i + ": " + ex.Message) + "\n";
     }


     ErgebnisListe.Add(Ergebnis);
     this.C_Ergebnis.ItemsSource = ErgebnisListe;
    }




   } // Ende Schleife über 10 Flüge

   try
   {
    if (c.State == CommunicationState.Opened) c.Close();
    System.Windows.Forms.MessageBox.Show("Dauer= " + sw.ElapsedMilliseconds + " ms");
   }
   catch (System.Exception ex)
   {
    System.Windows.Forms.MessageBox.Show("Fehler= " + ex.Message);
   }

   sw.Stop();




  }

  private void Start_Click(object sender, RoutedEventArgs e)
  {
   C_Szenarien_MouseDoubleClick(null, null);
  }

  private void Leeren_Click(object sender, RoutedEventArgs e)
  {
   this.ErgebnisListe.Clear();
   this.C_Ergebnis.ItemsSource = null;
  }

  private void Ende_Click(object sender, RoutedEventArgs e)
  {
   this.Close();
  }

  private void C_Szenarien_SelectionChanged(object sender, SelectionChangedEventArgs e)
  {
   var Szenario = (this.C_Szenarien.SelectedItem as Szenario);
   if (Szenario == null) return;
   this.C_OneWay.IsChecked = Szenario.IsOneWay;
  }
 }

 class View
 {
  public int ID { get; set; }
  public string Spalte1 { get; set; }
  public string Spalte2 { get; set; }
 }

}
