using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using de.WWWings.WCF;
using de.ITVisions.DemoViewer;
using System.ServiceModel;

namespace de.WWWings.ConsoleClient
{
 public class WCFClientDemos35EF
 {
  public static void RunEigeneChannelFactory()
  {
   BasicHttpBinding myBinding = new BasicHttpBinding();
   EndpointAddress myEndpoint = 
    new EndpointAddress("http://localhost:88/Webservices/Flugplanservice.svc");

   // Factory erstellen
   ChannelFactory<IFlugplanService> myChannelFactory = 
    new ChannelFactory<IFlugplanService>(myBinding, myEndpoint);
   IFlugplanService client = myChannelFactory.CreateChannel();
   // Client nutzen
   var f = client.HoleFlug(101);

   Console.WriteLine("Flug: " + f.FlugNr + " von " + f.AbflugOrt + " nach " + f.ZielOrt + " hat " + f.FreiePlaetze + " freie Pltze!");

  }

  public static void Run()
  {

   System.Threading.Thread.Sleep(2000);
   const int PID = 97;
   // === Instanziierung der Dienste

   FlugplanServiceEFClient client = new
   FlugplanServiceEFClient("FlugplanserviceEF_TCP");

   de.ITVisions.Util.Headline("---- Test 1: Einzelobjekt ndern");

   de.WWWings.GO.Flug f = client.GetFlug(180);

   Console.WriteLine("Flug: " + f.FlugNr + " von " + f.Abflugort + " nach " + f.Zielort + " hat " + f.FreiePlaetze + " freie Pltze!");
   if (f.Pilot != null) Console.WriteLine("Pilot: " + f.Pilot.Mitarbeiter.Person.Name);
   Console.WriteLine("Gebuchte Passagiere");
   foreach (  de.WWWings.GO.Passagier p in f.Passagier)
   {
    Console.WriteLine("Passagier: " + p.PersonID + " Name: " + p.Person.Name);
   }

   f.FreiePlaetze--;
   //Flugplanverwaltung.Passagier pneu = new de.WWWings.Flugplanverwaltung.Passagier();
   //pneu.PS_ID = 2222;
   Console.WriteLine("Freie Pltze nun: " + f.FreiePlaetze);

   Console.WriteLine("Speichern...");

   client.SaveFlug(f);

  
   f = client.GetFlug(101);
  Console.WriteLine("Kontrolle: " + f.FreiePlaetze);
  de.ITVisions.Util.Headline("---- Test 2: Flug lschen");

   int NeueFlugNummer = 10;
   try
   {
    de.WWWings.GO.Flug fd = client.GetFlug(NeueFlugNummer);

    client.DeleteFlug(fd);
   }
   catch (Exception ex)
   {
    Console.WriteLine("Flug lschen: " + ex.Message);
   }


   de.ITVisions.Util.Headline("---- Test 3: Objekt an List anfgen");

   long Anz;

   //Console.WriteLine("Anzahl Flge: " + client.C .CountFluege());

   List<de.WWWings.GO.Flug> AlleFluege = client.GetFluege();

   de.WWWings.GO.Flug fneu = new de.WWWings.GO.Flug();
   fneu.Abflugort = "Montreal";
   fneu.Zielort = "Stuttgart";
   fneu.FreiePlaetze = 250;
   fneu.Plaetze = 250;
   fneu.Memo = "per Code angelegt " + DateTime.Now;
   fneu.NichtRaucherFlug = true;
   fneu.FlugNr = NeueFlugNummer;
   fneu.Datum = DateTime.Now;

   AlleFluege = AlleFluege.Take(NeueFlugNummer).ToList();
   AlleFluege.Add(fneu);

  Console.WriteLine( client.SaveFluege(AlleFluege));

   //Console.WriteLine("Anzahl Flge: " + client.CountFluege());
  }


  
 }
}
