﻿using System;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using de.WWWings.WCF;

namespace de.WWWings.WCFClientDemos
{
 public class WCFClientDemosEF_ChannelFactory
 {

  /// <summary>
  /// Komplett code-basierter Nutzung eines WCF-Dienstes mit SharedContract und ChannelFactory
  /// (ohne generiertem Code in Client!)
  /// </summary>
  public static void Run()
  {

   // ABC zusammensetzen
   string URL = "http://localhost:88/Webservices/FlugplanserviceEF.svc";
   Binding clientBinding = new BasicHttpBinding();
   ContractDescription contract = ContractDescription.GetContract(typeof(IFlugplanServiceEF));
   ServiceEndpoint Endpoint = new ServiceEndpoint(contract, clientBinding, new EndpointAddress(URL));

   // ChannelFactory nutzen
   using (ChannelFactory<de.WWWings.Vertraege.IFlugplanServiceEF> factory = new ChannelFactory<de.WWWings.Vertraege.IFlugplanServiceEF>(Endpoint))
   {
    // Proxy erzeugen
    de.WWWings.Vertraege.IFlugplanServiceEF proxy = factory.CreateChannel();
    using (proxy as IDisposable)
    {
     // Operation aufrufen
     de.WWWings.GO.Flug f = proxy.GetFlug(101);

     Console.WriteLine(f.ToString());
    }

   }
   Console.ReadLine();
  }
 }
}
