using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using de.WWWings.WCF;

namespace de.WWWings
{
 public class Helper

    {

        static readonly String TokenContextFileName = "token_context.bin";

 

        public static IDictionary<String, String> LoadContext()

        {

            IDictionary<String, String> ctx = null;

 

            try

            {

                using (FileStream fs = 

                    new FileStream(TokenContextFileName, FileMode.Open, FileAccess.Read))

                {

                    BinaryFormatter bf = new BinaryFormatter();

                    ctx = bf.Deserialize(fs) as IDictionary<String, String>;

                    fs.Close();

                }

            }

            catch (Exception ex)

            {

            }

            return ctx;

        }

 

        public static void SaveContext(IClientChannel channel)

        {

            IContextManager cm = channel.GetProperty<IContextManager>();

            IDictionary<String, String> ctx = cm.GetContext() as IDictionary<String, String>;

 

            try

            {

                using (FileStream fs = new FileStream(TokenContextFileName, FileMode.Create))

                {

                    BinaryFormatter bf = new BinaryFormatter();

                    bf.Serialize(fs, ctx);

                    fs.Close();

                }

            }

            catch (Exception ex)

            {

            }

        }

 

        public static void DeleteContext()

        {

            try

            {

                File.Delete(TokenContextFileName);

            }

            catch (Exception ex)

            {

            }

        }

 

        public static void SetContext(IClientChannel channel, IDictionary<String, String> ctx)

        {

            IContextManager cm = channel.GetProperty<IContextManager>();

            cm.SetContext(ctx);

        }

    }



 class WCFDemos : ITestServiceCallback
 {
     public static int Counter = 0;
  public void WCF_WarteschlangenDemo()
  {
   Protokoll.ProtokollServiceClient ps = new Protokoll.ProtokollServiceClient();

   for (int a = 1; a < 11; a++)
   {
       Counter++;
    ps.Write("Nachricht #" + Counter.ToString());
    Console.WriteLine("Sende Nachricht #" + Counter);
   }
   ps.Close();
  }


  public void WCF_DurableServices()

  {

   //   de.WWWings.WCFDienste.ZustandsdienstClient client = new    de.WWWings.WCFDienste.ZustandsdienstClient();
   //client.Open();
   // Helper.SaveContext(client.InnerChannel);

   // client.SendData(10);
   // client.SendData(11);
   // client.SendData(12);
   // client.SendData(13);
   // Console.WriteLine(client.GetLastAccess());
   // Console.WriteLine(client.Count());
   // Console.ReadLine();
   // client.SendData(14);
   // Console.WriteLine(client.GetLastAccess());
   // Console.WriteLine(client.Count());
   // Console.ReadLine();
   // client.Close();

   }



  
  public void WCF_OneWayAndTwoWay()
  {

   TestServiceClient proxy;

   proxy = new TestServiceClient(new InstanceContext(this), "TestService_TCP");

   // Festlegung der Art der Verwendung der Identitt
   proxy.ClientCredentials.Windows.AllowedImpersonationLevel = System.Security.Principal.TokenImpersonationLevel.Impersonation;

   // Andere Identitt
   //proxy.ClientCredentials.Windows.ClientCredential.UserName = "Meier";
   //proxy.ClientCredentials.Windows.ClientCredential.Domain = "it-visions.local";
   //proxy.ClientCredentials.Windows.ClientCredential.Password = "geheim#123";
   //Console.WriteLine("Instanziiert...");

   //Console.ReadLine();
   PingInfo p = proxy.Ping();
   Console.WriteLine(p.Session);
   Console.WriteLine(p.ServerIdentity);
   Console.WriteLine(proxy.GetServerIdentity());
   //Console.WriteLine(proxy.GetServerIdentity_Impersonated());
   proxy.SendeLebenszeichen("Console");
   proxy.SendeLebenszeichen("Console");

   // Parameter Demo

   long x = 1;
   long y = 2;
   long z = 3;
   long e = proxy.ParameterDemo(x,ref y, out z);

   Console.WriteLine("x = {0}, y = {1}, z = {2}, e = {3}", x, y, z, e);


   //t.SitzungBeenden();
   proxy.SendeLebenszeichen("Console");
   proxy.SendeLebenszeichen("Console");
   proxy.Close();

   proxy = new TestServiceClient(new InstanceContext(this), "TestService_TCP");

   p = proxy.Ping();
   //Console.WriteLine(p.Session);

   proxy.SendeLebenszeichen("Console");
   proxy.SendeLebenszeichen("Console");
   proxy.Close();

   //BspWCFDuplex();
  }


  public void WCF_BspWCFDuplex()
  {
   TestServiceClient t = new TestServiceClient(new InstanceContext(this), "TestService_TCP");
   t.AsyncPing("KonsolenClient");
   Console.ReadLine();
   t.Close();
  }


  #region ITestServiceCallback Members

  public void ClientPing(string Server)
  {
   Console.WriteLine("Callback vom Server: " + Server);
  }

  #endregion



  #region Session Demo

 static TestServiceClient _proxy_for_session_demo;

  static public TestServiceClient proxy_for_session_demo
  {
   get { 
    if (_proxy_for_session_demo == null)
    _proxy_for_session_demo = new TestServiceClient(new InstanceContext(new WCFDemos()), "TestService_TCP");
      return _proxy_for_session_demo;
 }
  }


  static public void WCF_Session_Counter()
  {
   Console.WriteLine("Context mode = " + proxy_for_session_demo.GetInstanceContextMode());
   Console.WriteLine("Operation Counter = " + proxy_for_session_demo.GetOperationCount2());
  }

  static public void WCF_Session_Recycle()
  {
   proxy_for_session_demo.NeueSitzung();
   }
  

  static public void WCF_Session_End()
  {
   //Console.WriteLine("Operation Counter = " + proxy_for_session_demo.GetOperationCount());
   Console.WriteLine("Sitzung beendet!");
   proxy_for_session_demo.SitzungBeenden();
  }

  static public void WCF_Session_Operation()
  {
   double x = DateTime.Now.Second;
   double y = DateTime.Now.Minute;
   double e = proxy_for_session_demo.Add(x, y);

   Console.WriteLine("Operation: {0} + {1} = {2}.",x,y,e);
  } 
	#endregion
}
}