using System;
using System.Collections.Generic;
using System.Text;

using System.Management.Automation;
using System.Management;

namespace de.ITVisions.PowerShell
{
 [Cmdlet(VerbsCommon.Get, "Flug", DefaultParameterSetName = "")]
 public class Get_Flug : PSCmdlet
 {
  [ValidateLength(3, 30)]
  [Parameter(Position = 0, ValueFromPipeline = true, HelpMessage = "Optionale Angabe: Abflugort")]
  public string Abflugort = "";

  [Parameter(Position = 1, ValueFromPipeline = true, HelpMessage="Optionale Angabe: Zielort")]
  [ValidateLength(3,30)]
  public string Zielort = "";

  [Parameter(ValueFromPipeline = true, HelpMessage = "Optionale Angabe: Flugnummer")]
  [ValidateRange(100,10000)]
  public long ID = 0;

    protected override void ProcessRecord()
  {
   Util.SetConnection(this);
   if ((this.ID > 0 ) )
   {
    this.WriteObject(de.WWWings.FlugBLManager.HoleFlug(this.ID));
    return;
   }

   if ((this.Abflugort == "") && (this.Zielort == ""))
   {
    this.WriteObject(de.WWWings.FlugBLManager.HoleAlle(), true);
   }
   else
   {
    this.WriteObject(de.WWWings.FlugBLManager.HoleAlle(this.Abflugort, this.Zielort), true);
   }
  }
 }
}


