using System;
using System.Collections.Generic;
using System.Text;

using System.Management.Automation;
using System.Management;
using de.WWWings.PassagierSystem;

namespace de.ITVisions.PowerShell
{
    [Cmdlet(VerbsCommon.Remove, "Buchung", DefaultParameterSetName = "", SupportsShouldProcess = true)]
    public class Remove_Buchung : PSCmdlet
    {
        [Parameter(Position = 0, ValueFromPipeline = true)]
        public long Buchungscode = 0;

        [Parameter(Position = 1, ValueFromPipeline = true)]
        public long PassagierID = 0;

        protected override void ProcessRecord()
        {
            Util.SetConnection(this);
            if ((this.PassagierID > 0))
            {
                Passagier p = de.WWWings.Passagier_BLManager.HolePassagier(this.PassagierID);

                if (this.ShouldProcess(p.Buchungen.Count + " Buchungen fr Passagier " + p.GanzerName, "Lschen"))
                    this.WriteObject(de.WWWings.Buchung_BLManager.AlleBuchungenLoeschenFuerPassagier(this.PassagierID));
            }
            else
            {
                if (this.ShouldProcess("Buchung " + this.Buchungscode, "Lschen"))
                    this.WriteObject(de.WWWings.Buchung_BLManager.BuchungenLoeschen(this.Buchungscode));
            }
        }
    }
}


