﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Samples.PowerShell.Host;
using System.Runtime.InteropServices;
using System.Management.Automation;

namespace Host03
{
    public partial class WWWingsHostWindow : Form
    {
      

        private void WPSHostWindow_Load(object sender, EventArgs e)
        {
            this.C_Ausgabe.SelectionTabs = new int[] { 50, 100, 150, 200, 250 };
        }


        // ------------------ Events
        public class CommandEnteredEventArgs : EventArgs
        {
            public string Command = "";
        }
        delegate void StringParameterDelegate(string value);

        public event EventHandler<CommandEnteredEventArgs> CommandEntered;

        // ------------------ Methods
        private void Print(string s)
        {
            if (InvokeRequired)
            {
                BeginInvoke(new StringParameterDelegate(Print), new object[] { s });
                return;
            }


            this.C_Ausgabe.AppendText(s);
        }

        public void Write(string s)
        {
            Print(s);
            Application.DoEvents();
        }

        public void WriteLine(string s)
        {
            Print(s + "\n");
            Application.DoEvents();
        }

        public WWWingsHostWindow()
        {
            InitializeComponent();
        }

        private void C_Start_Click(object sender, EventArgs e)
        {
        
          string cmd = this.C_Eingabe.Text;
          Execute(cmd);
         
        }

        private void AutoExecute(string cmd)
        {
            this.C_Eingabe.Text = cmd;
            Execute(cmd);
        }

        private void Execute(string cmd)
        {
         if (this.C_Clear.Checked) this.C_Ausgabe.Clear();
         if (CommandEntered != null)
         {
                            
           WriteLine("Executing " + cmd + "...");
         if (this.C_WPS2API.Checked)
         {
          PowerShell ps = PowerShell.Create();

          ps.AddScript(this.C_Eingabe.Text);
        
          foreach (PSObject result in ps.Invoke())
          {
           foreach (PSMemberInfo p in result.Properties)
           {
            string value = "";
            try
            {
             value = p.Value.ToString();
            }
            catch (Exception)
            {
            }

            if (value.Length > 15) value = value.Substring(0, 12) + "...";
            if (p.MemberType != PSMemberTypes.ScriptProperty)            
             this.Write(string.Format("{0,15}", value));
           }

           this.WriteLine("");
           //string.Format(
           //       "{0,-24}{1}",
           //       result.Members["ProcessName"].Value,
           //       result.Members["Id"].Value));
          } // End foreach.

         }
         else
         {

           CommandEnteredEventArgs arg = new CommandEnteredEventArgs();
           arg.Command = cmd;
           CommandEntered(this, arg);
          }
         }
         }
        

        private void leerenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.C_Ausgabe.Clear();
        }

        private void beendenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void getFlugRomFTFlugNrZielortToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.AutoExecute("Get-Flug Rom | FT FlugNr, Zielort");
        }

        private void getFlugRomFTToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.AutoExecute("Get-Flug Rom | FT");
        }

        private void getPassagierToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.AutoExecute("Get-Passagier");
        }

        private void getProcessToolStripMenuItem_Click(object sender, EventArgs e)
        {
         this.AutoExecute("Get-Process");
        }

     

    }
}
