﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Silverlight.WCFService;
using ITVisions;
using System.IO.IsolatedStorage;
using System.Runtime.InteropServices.Automation;
using SilverlightSharedLibrary;

namespace Silverlight
{
  public partial class InfoWindow : ChildWindow
  {
    public InfoWindow()
    {
      InitializeComponent();
      this.GetServerInfo();
      Application.Current.Host.Content.Resized += new EventHandler(Content_Resized);
    }
    ServerInfo si;
    protected void GetServerInfo()
    {
      try
      {
        WCFServiceClient client = new WCFServiceClient();
        client.GetInfoCompleted += new EventHandler<GetInfoCompletedEventArgs>(client_GetInfoCompleted);
        client.GetInfoAsync();
      }
      catch (Exception ex)
      {
        si.Assembly = "Server nicht verfügbar: " + ex.GetWholeMessage();
      }

    }


    protected ClientInfo GetClientInfo()
    {
      ClientInfo ci = new ClientInfo();

      try
      {

        if (App.Current.IsRunningOutOfBrowser && App.Current.HasElevatedPermissions)
        {
          if (AutomationFactory.IsAvailable)
          {

            dynamic shell = AutomationFactory.CreateObject("Wscript.shell");
            string key = @"HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProductName";
            ci.OSProductName = shell.RegRead(key);

            key = @"HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\CurrentBuild";
            ci.OSBuild = shell.RegRead(key);

            //key = @"HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\InstallDate";
            //this.C_InfoText.Text += "InstallDate:" + shell.RegRead(key) + "\n";

            //key = @"HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProductId";
            //this.C_InfoText.Text += "ProductID:" + shell.RegRead(key) + "\n";

            //key = @"HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\SoftwareType";
            //this.C_InfoText.Text += "SoftwareType:" + shell.RegRead(key) + "\n";


            dynamic network = AutomationFactory.CreateObject("Wscript.network");
            ci.ComputerName = network.ComputerName;
            ci.Identity = network.UserDomain + @"\" + network.UserName;
            
            //shell.Popup(network.Unsinn);


          }
          else
          {
        
          }

        }
      }
      catch (Exception ex)
      {

        MessageBox.Show("COM-Zugriffsproblem: " + ex.GetWholeMessage());
      }

      return ci;

    }

    void client_GetInfoCompleted(object sender, GetInfoCompletedEventArgs e)
    {
      si = e.Result;
      UIUpdate();
    }

    private void UIUpdate()
    {
      this.C_InfoText.TextWrapping = TextWrapping.Wrap;
         this.C_InfoText2.TextWrapping = TextWrapping.Wrap;

      this.C_InfoText.Text = "Client Info:\n" + GetClientInfo().ConvertToStringsWithNames() + "\n";

      this.C_InfoText.Text += "\n";
      this.C_InfoText.Text += "Silverlight Info:\n";

      this.C_InfoText.Text += "HasElevatedPermissions: " + Application.Current.HasElevatedPermissions + "\n" +
        "InstallState: " + Application.Current.InstallState + "\n" +
        "IsRunningOutOfBrowser: " + Application.Current.IsRunningOutOfBrowser + "\n" +
        //"MainWindow: " + Application.Current.MainWindow.ToString() + "\n" +
        "IsFullScreen: " + Application.Current.Host.Content.IsFullScreen + "\n" +
         "ZoomFactor: " + Application.Current.Host.Content.ZoomFactor + "\n" +
            "ActualHeight: " + Application.Current.Host.Content.ActualHeight + "\n" +
            "ActualWidth: " + Application.Current.Host.Content.ActualWidth + "\n";
      IsolatedStorageFile iso = IsolatedStorageFile.GetUserStoreForApplication();
      this.C_InfoText.Text += "Isolated Storage:\n";
      this.C_InfoText.Text += "Quota:" + iso.Quota + "\n";
      this.C_InfoText.Text += "AvailableFreeSpace:" + iso.AvailableFreeSpace + "\n";
      this.C_InfoText.Text += "UsedSize:" + iso.UsedSize + "\n";
      this.C_InfoText.Text += "Directories:" + string.Join(";", iso.GetDirectoryNames("*").ToList()) + "\n";
      this.C_InfoText.Text += "Files:" + string.Join(";", iso.GetFileNames("*.*").ToList()) + "\n";



      this.C_InfoText2.Text = "Server Info:\n" + si.ConvertToStringsWithNames();

     
    }


    private void OKButton_Click(object sender, RoutedEventArgs e)
    {
      this.DialogResult = true;
    }

    private void CancelButton_Click(object sender, RoutedEventArgs e)
    {
      this.DialogResult = false;
    }

    void Content_Resized(object sender, EventArgs e)
    {
      UIUpdate();
    }

    private void UpdateButton_Click(object sender, RoutedEventArgs e)
    {
      GetServerInfo();
    }

    private void CopyToClipboard_Click(object sender, RoutedEventArgs e)
    {
      try
      {
        Clipboard.SetText(this.C_InfoText.Text + "\n" + this.C_InfoText2.Text);
        MessageBox.Show("Informationen liegen jetzt in Zwischenablage!");


      }
      catch (Exception ex)
      {
        MessageBox.Show("Kein Zugang zur Zwischenablage: " + ex.GetWholeMessage());
      }
    }

  }
}

