﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using WWWings_Silverlight.FlugplanDataservice;
using System.Data.Services.Client;
using System.Linq;
using WWWings_RIAServices.Web;
using System.Windows.Ria;
using System.Net.NetworkInformation;
using System.IO.IsolatedStorage;
using System.IO;
using System.Runtime.Serialization;
using System.Windows.Controls.Ria;
using WWWings_Silverlight;
using System.Net;
using System.Xml.Linq;


namespace SilverlightApplication3
{
 public partial class UI_Fluege_DataService : ITVSLDemoWindow
 {

  // Variablen
  List<Flug> Daten;
  Entities db;
  DataServiceQuery<Flug> AbfrageObjekt;
  FlugDetails d = new FlugDetails();

  public UI_Fluege_DataService()
   : base()
  {
   // Required to initialize variables
   InitializeComponent();
   //this.FlugDataSource.IsLoadingData

   // Combox init
   this.C_Anzahl.ItemsSource = new List<string>() { "Alle", "5", "10", "15", "20", "50" };
   this.C_Anzahl.SelectedIndex = 0;

   // Statisch...
   //this.C_Ort.ItemsSource = new List<string>() { "Alle", "Rom", "Berlin", "Paris", "Mailand", "Moskau", "Essen/Mülheim" };
   // this.C_Ort.SelectedIndex = 1;
   // oder via Service!


   // Hinweis: Generische Query geht nicht in .NET 3.5. Daher eigene WebGet-Operation GetOrte
   // Die kann man aber auch nicht für db.BeginExecute aufrufen, weil primitive Typen nicht unterstützt werden
   // Einzige Lösung: Selbst parsen


   WebClient wc = new WebClient();
   wc.DownloadStringAsync(new Uri("http://localhost:93/DataService.svc/GetOrte"));
   wc.DownloadStringCompleted += (s, e) =>
   {
    XDocument xdoc = XDocument.Parse(e.Result);
    List<string> Orte = xdoc.Root.Descendants(((XNamespace)@"http://schemas.microsoft.com/ado/2007/08/dataservices") + "element").Select(xe => xe.Value).ToList();
    Orte.Insert(0, "Alle");
    this.C_Ort.ItemsSource = Orte;
    this.C_Ort.SelectedIndex = 0;
   };


   // nur für manuellen Start der Animation
   //this.C_LoadingGrid.Visibility = Visibility.Collapsed;


   this.C_Status.Text = ("Silverlight-Anwendung ist bereit.");

   Application.Current.CheckAndDownloadUpdateCompleted += new CheckAndDownloadUpdateCompletedEventHandler(Current_CheckAndDownloadUpdateCompleted);

   if (Application.Current.IsRunningOutOfBrowser)
   {
    this.C_Install.Content = "Update";
   }
   NetStat();
   NetworkChange.NetworkAddressChanged += new NetworkAddressChangedEventHandler(NetworkChange_NetworkAddressChanged);


   this.FlugDataSource.LoadedData += new EventHandler<LoadedDataEventArgs>(FlugDataSource_LoadedData);
  }



  void NetworkChange_NetworkAddressChanged(object sender, EventArgs e)
  {
   NetStat();
  }

  private void NetStat()
  {
   string s = GetNetStat();
   this.C_Network.Text = s;
  }


  private void GetOrteCompleted(InvokeOperation<IEnumerable<string>> op)
  {
   List<string> Orte = new List<string>() { "Alle" };
   Orte.AddRange(op.Value);
   this.C_Ort.ItemsSource = Orte;
   this.C_Ort.SelectedIndex = 0;
  }


  // Variablen
  FlugDomContext dc = new FlugDomContext();

  // Änderungen an Kontext melden
  void C_Liste_RowEditEnding(object sender, DataGridRowEditEndingEventArgs e)
  {
   this.C_Status.Text = ("Zeile geändert: " + e.Row.GetIndex().ToString());
   Flug f = ((sender as DataGrid).ItemsSource as List<Flug>)[e.Row.GetIndex()];
   db.UpdateObject(f);
  }

  private void C_Lesen_Click(object sender, System.Windows.RoutedEventArgs e)
  {

   this.C_Status.Text = ("Flüge laden...1");
   // Daten laden
   db = new Entities(new Uri("DataService.svc", UriKind.Relative));
   this.C_Status.Text = ("Flüge laden...2");
   var q = (from f in db.Flug select f);
   if (C_Ort.SelectedItem.ToString() != "Alle")
   {
    q = q.Where(f => f.Abflugort == C_Ort.SelectedItem.ToString());
   }
   if (C_Anzahl.SelectedItem.ToString() != "Alle")
   {
    q = q.Take(Convert.ToInt32(this.C_Anzahl.SelectedItem.ToString()));
   }
   this.C_Status.Text = ("Flüge laden...3");
   AbfrageObjekt = (DataServiceQuery<Flug>)q;
   this.C_Status.Text = ("Flüge laden...4");

   AbfrageObjekt.BeginExecute(new AsyncCallback(OnLoadComplete), null);
  }

  // Daten geladen
  void OnLoadComplete(IAsyncResult result)
  {
   Daten = AbfrageObjekt.EndExecute(result).ToList();
   // this.C_Liste.ItemsSource = null; // Wenn nicht aktualisiert!
   this.C_Fluege.ItemsSource = Daten;
   this.C_Status.Text = ("Flüge geladen!");
  }

  void FlugDataSource_LoadedData(object sender, LoadedDataEventArgs e)
  {

   this.C_Status.Text = ("Lade Flüge... (4)");
   //this.C_Fluege.Visibility = Visibility.Collapsed;
  }

  private void OnLoadCompleted(LoadOperation<WWWings35_GO.EF.Flug> lo)
  {
   if (lo.HasError)
   {
    MessageBox.Show(string.Format("Load Failed: {0}", lo.Error.Message));
    lo.MarkErrorAsHandled();
   }
   this.C_Fluege.ItemsSource = lo.Entities.ToArray(); //dc.Flugs wenn man es über lo.completed macht!;
   this.C_Status.Text = lo.Entities.Count() + " Flüge geladen.";


   // nur für manuelles Ende der Animation!
   //this.C_Fluege.Visibility = Visibility.Visible;
   //this.C_LoadingGrid.Visibility = Visibility.Collapsed;
  }

  // Speichern
  private void C_Speichern_Click(object sender, RoutedEventArgs e)
  {
   d.C_DataForm.CommitEdit();
   C_Fluege.CommitEdit();

   db.BeginSaveChanges(new AsyncCallback(OnSaveAllComplete), null);
  }
  // Speichern fertig
  void OnSaveAllComplete(IAsyncResult result)
  {
   DataServiceResponse response =
     (DataServiceResponse)db.EndSaveChanges(result);
   this.C_Status.Text = ("Flüge gespeichert: " + response.Count());
  }


  #region Caching
  /// <summary>
  /// Schreibe Cache
  /// </summary>
  /// <remarks>
  /// // Nur zum testen
  /// StreamWriter writer = new StreamWriter(fileStream);
  /// writer.Write(DateTime.Now.ToString());
  /// </remarks>
  private void C_Cache_Save_Click(object sender, RoutedEventArgs e)
  {

   // Vorbereiten der Daten
   WWWings35_GO.EF.Flug[] fluege;
   if (this.C_Fluege.ItemsSource is DomainDataSourceView)
   {
    fluege = (this.C_Fluege.ItemsSource as DomainDataSourceView).ToArray();
   }
   else
   {
    fluege = this.C_Fluege.ItemsSource as WWWings35_GO.EF.Flug[];
   }

   string s = Export(fluege);
   if (s != "")
   {
    // Anzeige
    MessageBox.Show(s, "Speichern im Cache", MessageBoxButton.OK);
    this.C_Status.Text = s;
   }
  }


  /// <summary>
  /// Laden aus Cache
  /// </summary>
  private void C_Cache_Load_Click(object sender, RoutedEventArgs e)
  {
   WWWings35_GO.EF.Flug[] fluege = Import();
   if (fluege != null)
   {
    // Anzeigen
    this.C_Fluege.ItemsSource = fluege;
    this.C_Status.Text = fluege.Count() + " Datensätze aus Cache geladen!";
   }
  }


  private void C_Details_Click(object sender, RoutedEventArgs e)
  {
   if (this.C_Fluege.SelectedItem == null) return;
 

   d.CurrentItem = this.C_Fluege.SelectedItem;
   d.Show();
  }
  #endregion

  #region Sonstiges
  /// <summary>
  /// Anzeige leeren
  /// </summary>
  public void C_Clear_Click(object sender, RoutedEventArgs e)
  {
   // geht nicht, weil es nicht wirkt, wenn die Daten aus dem Cache kommen!
   // this.FlugDataSource.Clear()
   this.C_Fluege.ItemsSource = null;
   this.C_Status.Text = "Bereit";
  }

  /// <summary>
  /// Lokale Installation
  /// </summary>
  public void C_Install_Click(object sender, RoutedEventArgs e)
  {
   InstallOutOfBrowser();
  }
  
  #endregion
 }
}