﻿
namespace SilverlightServices
{
 using System;
 using System.Collections.Generic;
 using System.ComponentModel;
 using System.ComponentModel.DataAnnotations;
 using System.Data;
 using System.Linq;
 using System.ServiceModel.DomainServices.EntityFramework;
 using System.ServiceModel.DomainServices.Hosting;
 using System.ServiceModel.DomainServices.Server;
 using de.WWWings.GO;


 // Implements application logic using the ConnString_WWWings6_EF context.
 // TODO: Add your application logic to these methods or in additional methods.
 // TODO: Wire up authentication (Windows/ASP.NET Forms) and uncomment the following to disable anonymous access
 // Also consider adding roles to restrict access as appropriate.
 // [RequiresAuthentication]
 [EnableClientAccess()]
 public class FlugDomService : LinqToEntitiesDomainService<WWWings6Entities>
 {

  // TODO:
  // Consider constraining the results of your query method.  If you need additional input you can
  // add parameters to this method or create additional query methods with different names.
  // To support paging you will need to add ordering to the 'Flug' query.
  [Query(IsDefault = true)]
  public IQueryable<Flug> GetFlug()
  {
   return this.ObjectContext.Flug;
  }

  public void InsertFlug(Flug flug)
  {
   if ((flug.EntityState != EntityState.Detached))
   {
    this.ObjectContext.ObjectStateManager.ChangeObjectState(flug, EntityState.Added);
   }
   else
   {
    this.ObjectContext.Flug.AddObject(flug);
   }
  }

  public void UpdateFlug(Flug currentFlug)
  {
   this.ObjectContext.Flug.AttachAsModified(currentFlug, this.ChangeSet.GetOriginal(currentFlug));
  }

  public void DeleteFlug(Flug flug)
  {
   if ((flug.EntityState == EntityState.Detached))
   {
    this.ObjectContext.Flug.Attach(flug);
   }
   this.ObjectContext.Flug.DeleteObject(flug);
  }

  // Eigene Zusätze:

  #region Eigener Code
  public IQueryable<Flug> GetFlugByOrt(string Ort)
  {
   return this.ObjectContext.Flug.Where(f => f.Abflugort == Ort);
  }

  public List<Flug> GetFlugByOrtAsList(string Ort)
  {
   return this.ObjectContext.Flug.Where(f => f.Abflugort == Ort).ToList();
  }

  [Invoke]
  public List<string> GetOrte()
  {
   List<string> Orte = (from f in this.ObjectContext.Flug select f.Abflugort).Distinct().ToList();
   return Orte;
  } 
  #endregion
 }
}


