using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using de.WWWings.GO;

namespace WebUI_MVC.Controllers
{
 public class FlugController : Controller
 {

  de.WWWings.GO.WWWings6Entities _db;

  public FlugController()
  {
   _db = new de.WWWings.GO.WWWings6Entities();
  }

  public ActionResult Index()
  {

   ViewData.Model = _db.Flug.Where(f => f.FlugNr < 110).ToList();
   return View();
  }


  public ActionResult Add()
  {
   return View("Add");
  }

  [AcceptVerbs(HttpVerbs.Post)]
  public ActionResult Add(FormCollection form)
  {
   var Flug = new Flug();

   // Deserialisieren
   TryUpdateModel(Flug, new string[] { "FlugNr", "Abflugort", "Zielort" }, form.ToValueProvider());

   // Validieren
   if (String.IsNullOrEmpty(Flug.Abflugort))
    ModelState.AddModelError("Abflugort", "Abflugort is required!");
   if (String.IsNullOrEmpty(Flug.Zielort))
    ModelState.AddModelError("Zielort", "Zielort is required!");

   // Hinzufgen zur Datenbank
   if (ModelState.IsValid)
   {
    _db.AddToFlug(Flug);
    _db.SaveChanges();
    return RedirectToAction("Index");
   }

   // Sonst Anzeige erneuern
   return View(Flug);
  }


  public ActionResult Edit(int id)
  {
   // Zu aktualisierender Flug aus Datenbank holen
   var movieToUpdate = _db.Flug.First(m => m.FlugNr == id);

   ViewData.Model = movieToUpdate;
   return View("Edit");
  }

  [AcceptVerbs(HttpVerbs.Post)]
  public ActionResult Edit(FormCollection form)
  {
   // Zu aktualisierender Flug aus Datenbank holen
   int id = Int32.Parse(form["FlugNr"]);
   Flug flug = _db.Flug.First(m => m.FlugNr == id);

   // Deserialisieren
   TryUpdateModel(flug, new string[] { "Abflugort", "Zielort" }, form.ToValueProvider());

   // Validieren
   if (String.IsNullOrEmpty(flug.Abflugort))
    ModelState.AddModelError("Abflugort", "Abflugort ist erforderlich!");
   if (String.IsNullOrEmpty(flug.Zielort))
    ModelState.AddModelError("Zielort", "Zielort ist erforderlich!");

   // Speichern
   if (ModelState.IsValid)
   {
    _db.SaveChanges();
    return RedirectToAction("Index");
   }

   // Sonst, zeige Eingabeformular erneut an
   return View(flug);
  }


  public ActionResult Delete(int id)
  {
   // Zu lschenden Flug holen
   var flugtodelete = _db.Flug.First(m => m.FlugNr == id);

   // Speichern 
   _db.DeleteObject(flugtodelete);
   _db.SaveChanges();

   // Liste anzeigen
   return RedirectToAction("Index");
  }
 }
}
