using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

public partial class NEC : System.Web.UI.MasterPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
     if (!Page.IsPostBack)
     {
      PopulateRootLevel();
     }
    }

    private void PopulateRootLevel()
    {
     SqlConnection objConn = new SqlConnection(ConfigurationManager.ConnectionStrings["CS_WWWings"].ToString());
     SqlCommand objCommand = new SqlCommand("select MI_MitarbeiterNr,PE_Name,PE_Personalausweisnr, (select count(*) FROM Personen_Mitarbeiter  WHERE  MI_Vorgesetzter_MitarbeiterNr=sc.MI_MitarbeiterNr) childnodecount FROM Personen_Mitarbeiter sc where  MI_Vorgesetzter_MitarbeiterNr IS NULL", objConn);

     SqlDataAdapter da = new SqlDataAdapter(objCommand);
     DataTable dt = new DataTable();
     da.Fill(dt);

     TreeNode rootNote = new TreeNode("Mitarbeiter", "root");
     rootNote.ShowCheckBox = true;
     C_Nav.Nodes.Add(rootNote);

     PopulateNodes(dt, C_Nav.Nodes[0].ChildNodes);
    }

    private void PopulateNodes(DataTable dt, TreeNodeCollection nodes)
    {
     foreach (DataRow dr in dt.Rows)
     {
      TreeNode tn = new TreeNode();
      tn.Text = dr["PE_Name"].ToString() + " (" + dr["PE_Personalausweisnr"].ToString() + ")";
      tn.Value = dr["PE_Personalausweisnr"].ToString();

      //Nur zu Testzwecken!!
      if (tn.Text.Equals("Schwichtenberg"))
      {
       tn.Text = "<b>" + "Schwichtenberg" + "</b>";
       tn.ToolTip = "Hallo";
      }
      // Ende Test

      nodes.Add(tn);

      //If node has child nodes, then enable on-demand populating
      tn.PopulateOnDemand = Convert.ToBoolean(dr["childnodecount"]);
     }
    }

    private void PopulateSubLevel(int parentid, TreeNode parentNode)
    {
     SqlConnection objConn = new SqlConnection(ConfigurationManager.ConnectionStrings["CS_WWWings"].ToString());
     SqlCommand objCommand = new SqlCommand("select MI_MitarbeiterNr,PE_Personalausweisnr, PE_Name,(select count(*) FROM Personen_Mitarbeiter WHERE not MI_MitarbeiterNr is null and MI_Vorgesetzter_MitarbeiterNr=sc.MI_MitarbeiterNr) childnodecount FROM Personen_Mitarbeiter sc where MI_Vorgesetzter_MitarbeiterNr = @", objConn);

     objCommand.Parameters.Add("@MI_Vorgesetzter_MitarbeiterNr", SqlDbType.Int).Value = parentid;

     SqlDataAdapter da = new SqlDataAdapter(objCommand);
     DataTable dt = new DataTable();
     da.Fill(dt);
     PopulateNodes(dt, parentNode.ChildNodes);
    }

    protected void C_Nav_TreeNodePopulate(object sender, TreeNodeEventArgs e)
    {
     PopulateSubLevel(Convert.ToInt32(e.Node.Value), e.Node);
    }

    protected void C_Nav_SelectedNodeChanged(object sender, EventArgs e)
    {
     Response.Redirect("/Extranet/Mitarbeiterverwaltung/ShowDescription.aspx?ID=" + ((TreeView)sender).SelectedNode.Value);
    }
}
