﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="Fluege_DataJS_Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
 <title>OData-Client mit JavaScript</title>
</head>
<body>
 <form id="form1" runat="server">
 <div>
  <script src="../App_Scripts/jquery-1.7.2.min.js" type="text/javascript"></script>
  <script src="../App_Scripts/jquery-ui-1.8.21.custom.min.js" type="text/javascript"></script>
  <script src="../App_Scripts/datajs-1.0.3.min.js" type="text/javascript"></script>
  <script type="text/javascript">
   $(document).ready(function () {

    // URL für OData-Dienst
    var $url = "/Webservice/WWWingsFlugplanDataService.svc";
    var $query = "/Flug?$filter=Abflugort%20eq%20'Rom'%20and%20Zielort%20eq%20'Berlin'&$orderby=Datum%20desc&$skip=1&$top=5";

    // Entweder automatische Datumserkennung in DataJS
    OData.jsonHandler.recognizeDates = false;
    // oder explizite Metadaten für diesen OData-Dienst in DataJS
    OData.defaultMetadata.push(
    { namespace: "WWWings6Model",
     entityType: [{
      name: "Flug", property: [
          { name: "Datum", type: "Edm.DateTime" }, { name: "Ankunft", type: "Edm.DateTime" }
        ]
     }]
    }
  );
    log("Daten laden...");

    // Daten laden über DataJS
    OData.read($url + $query,
  function (data) {
   var html = "";

   // Ausgabe
   $.each(data.results, function (i, f) {
    html = "<div>" + f.FlugNr + " fliegt am " + $.datepicker.formatDate('dd.M.yy', f.Datum) + " von " + f.Abflugort + " nach " + f.Zielort + " und hat " + f.FreiePlaetze + " freie Plätze!</div>";
    $(html).appendTo($("#ausgabe"));

    // Plätze verringern
    f.FreiePlaetze--;

    // ---- Änderung speichern
    // Anfrage vorbereiten
    var $objektUrl = $url + "/Flug(" + f.FlugNr + ")";
    var requestOptions = { requestUri: $objektUrl, method: "PUT", data: f, headers: { "If-Match": " *"} };

    // Änderungsoperation ausführen
    OData.request(requestOptions, function () { log("Flug " + f.FlugNr + " gespeichert!"); }, function (err) { $("#log").append("Fehler: " + err.message); });

   });
  }
);

   });

   function log(s) {
    $("#log").append(s + "<br>");
   }


  </script>
  Flüge von OData-Dienst laden und ändern<hr />
  <span id="ausgabe"></span><a id="#" href="">Aktualisieren</a>
  <hr />
  <span id="log"></span>
 </div>
 </form>
</body>
</html>
