using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;
using de.WWWings;
using System.Runtime.CompilerServices;
using System.Linq;

namespace de.WWWings
{

 /// <summary>
 /// Initialsierung und Test der WWWings-Datenbank mit Hilfe der BL-Klassen stand .NET 2.0/3.0
 /// </summary>
 public class BO_Init
 {

  public static void Init()
  {
   Init_Fluege();
   Init_Passagiere();
   Init_Buchungen();
  }


  public static void Init_Passagiere()
  {
   string[] Nachnamen = { "Mller", "Meier", "Schulze", "Hirsch", "Kohl", "Schrder", "Merkel", "Fischer", "Westerwelle", "Gysi" };
   string[] Vornamen = { "Max", "Hans", "Helmut", "Gerhard", "Angela", "Joschka", "Guido", "Gregor" };

   long Nummer = 0;
   Passagier.AllePassagiere.Clear();

   foreach (string Vorname in Vornamen)
   {
    foreach (string Nachname in Nachnamen)
    {
     Passagier p = new Passagier();
     p.Vorname = Vorname;
     p.Nachname = Nachname;
     p.Geburtsdatum = DateTime.Now.AddYears(-Convert.ToInt32(new Random(p.GanzerName.Length).Next(1, 80)));
     p.PassagierID = Nummer;

     Nummer++;
    }

   }
   Console.WriteLine("Anzahl Passagiere nacher: " + Passagier.AllePassagiere.Count);
  }

  /// <summary>
  /// Initialisieren der Flugtabelle
  /// </summary>
  public static void Init_Fluege()
  {
   string[] Flughaefen = { "Berlin", "Frankfurt", "Mnchen", "Hamburg", "Kln/Bonn", "Rom", "London", "Paris", "Mailand", "Prag", "Moskau", "New York", "Seattle", "Essen/Mlheim", "Kapstadt", "Madrid", "Oslo", "Dallas" };
   Console.WriteLine("Tabelle FL_Fluege wird initialisiert...");


   Flug.AlleFluege.Clear();

   int FlugNr = 1000;
   foreach (string von in Flughaefen)
   {
    foreach (string nach in Flughaefen)
    {

     {
      if (von != nach)
      {
       DateTime FlugDatum = DateTime.Now.AddMinutes(Convert.ToInt64(new Random(Convert.ToInt32(DateTime.Now.Millisecond)).Next(5000)));
       int anz = new System.Random(nach.Length).Next(1, 5);
       for (byte a = 1; a <= 50; a++)
       {
        FlugDatum = FlugDatum.AddDays(1);
        long FreiePlaetze = Convert.ToInt32(new Random(nach.Length).Next(200));
        Flug f = new Flug();
        f.FlugNr = 100 + FlugNr;
        f.AbflugOrt = von;
        f.ZielOrt = nach;
        f.Plaetze = 250;
        f.FreiePlaetze = FlugNr; // FreiePlaetze;
        f.Datum = FlugDatum;
        FlugNr++;
       }
      }
     }
    }

   }
   Console.WriteLine("Anzahl Flge nacher: " + Flug.AlleFluege.Count);
  }


  /// <summary>
  /// Initialisieren der Flugtabelle
  /// </summary>
  public static void Init_Buchungen()
  {
   long Nummer = 0;
   foreach (Passagier p in Passagier.AllePassagiere)
   {
    int AnzBuchungen = new Random(p.GanzerName.Length).Next(20);
    for (int i = 1; i < AnzBuchungen; i++)
    {
     Nummer++;
     Flug f = (from f1 in Flug.AlleFluege select f1).ElementAtOrDefault(i);
     Buchung b = new Buchung(f, p);
     b.Buchungscode = Nummer;

    }



   }


  }
 }
}
