﻿using System;
using System.Linq;
using de.WWWings.Test.Modelle.EF6;
using de.WWWings.Test;

namespace de.WWWingsInit
{
 class DBInit_V6_mit_EF
 {


  // Sekunden löschen: UPDATE [WWWings6].[dbo].[Flug]
//   SET Datum  = convert(varchar(5), datum, 108)   




  /// <summary>
  /// Menge von Flügen erzeugen
  /// </summary>
  /// 
  static string[] Flughaefen = { "Berlin", "Frankfurt", "München", "Hamburg", "Köln/Bonn", "Rom", "London", "Paris", "Mailand", "Prag", "Moskau", "New York", "Seattle", "Essen/Mülheim", "Kapstadt", "Madrid", "Oslo", "Dallas" };
  const int ANZFluege = 1000;
  const int ANZPass = 1000;
  const int ANZBuchungenProFlug = 70;

  public static void Init_DB()
  {


   LTS.HeadLine("DB Version 6 Initialisieren");


   de.WWWings.Test.Modelle.EF6.WWWings6Entities db = new de.WWWings.Test.Modelle.EF6.WWWings6Entities();

   
   Console.WriteLine("Flüge zu Beginn: " + db.Flug.Count());
   Console.WriteLine("Passagiere zu Beginn: " + db.Passagier.Count());
   // Alle Buchungen löschen!
   db.ExecuteStoreCommand("Delete from Flug_Passagier");
   db.ExecuteStoreCommand("Delete from Flug");
   db.ExecuteStoreCommand("Delete from pilot");
   db.ExecuteStoreCommand("Delete from Mitarbeiter");
   db.ExecuteStoreCommand("Delete from Passagier");
   db.ExecuteStoreCommand("Delete from Person");

   Console.WriteLine("Flüge nach Löschen: " + db.Flug.Count());
   Console.WriteLine("Passagiere nach Löschen: " + db.Passagier.Count());

 //  Init_Passagiere(db);



   Init_Fluege(db);

   Init_Buchungen(db);

   Init_Mitarbeiter(db);

   Init_Piloten(db);
   Init_PilotenZuFluegen(db);

  }

  private static System.Random Init_Fluege( de.WWWings.Test.Modelle.EF6.WWWings6Entities  db)
  {


   string Memo = "";
   for (int i = 0; i < 10; i++)
   {
    Memo += "Weit hinten, hinter den Wortbergen, fern der Länder Vokalien und Konsonantien leben die Blindtexte. Abgeschieden wohnen Sie in Buchstabhausen an der Küste des Semantik, eines großen Sprachozeans. Ein kleines Bächlein namens Duden fließt durch ihren Ort und versorgt sie mit den nötigen Regelialien. Es ist ein paradiesmatisches Land, in dem einem gebratene Satzteile in den Mund fliegen. Nicht einmal von der allmächtigen Interpunktion werden die Blindtexte beherrscht – ein geradezu unorthographisches Leben. Eines Tages aber beschloß eine kleine Zeile Blindtext, ihr Name war Lorem Ipsum, hinaus zu gehen in die weite Grammatik. Der große Oxmox riet ihr davon ab, da es dort wimmele von bösen Kommata, wilden Fragezeichen und hinterhältigen Semikoli, doch das Blindtextchen ließ sich nicht beirren. Es packte seine sieben Versalien, schob sich sein Initial in den Gürtel und machte sich auf den Weg. Als es die ersten Hügel des Kursivgebirges erklommen hatte, warf es einen letzten Blick zurück auf die Skyline seiner Heimatstadt Buchstabhausen, die Headline von Alphabetdorf und die Subline seiner eigenen Straße, der Zeilengasse. Wehmütig lief ihm eine rhetorische Frage über die Wange, dann setzte es seinen Weg fort. Unterwegs traf es eine Copy. Die Copy warnte das Blindtextchen, da, wo sie herkäme wäre sie zigmal umgeschrieben worden und alles, was von ihrem Ursprung noch übrig wäre, sei das Wort 'und' und das Blindtextchen solle umkehren und wieder in sein eigenes, sicheres Land zurückkehren. Doch alles Gutzureden konnte es nicht überzeugen und so dauerte es nicht lange, bis ihm ein paar heimtückische Werbetexter auflauerten, es mit Longe und Parole betrunken machten und es dann in ihre Agentur schleppten, wo sie es für ihre Projekte wieder und wieder mißbrauchten. Und wenn es nicht umgeschrieben wurde, dann benutzen Sie es immernoch. Weit hinten, hinter den Wortbergen, fern der Länder Vokalien und Konsonantien leben die Blindtexte. Abgeschieden wohnen Sie in Buchstabhausen an der Küste des Semantik, eines großen Sprachozeans. Ein kleines Bächlein namens Duden fließt durch ihren Ort und versorgt sie mit den nötigen Regelialien. Es ist ein paradiesmatisches Land, in dem einem gebratene Satzteile in den Mund fliegen. Nicht einmal von der allmächtigen Interpunktion werden die Blindtexte beherrscht – ein geradezu unorthographisches Leben. Eines Tages aber beschloß eine kleine Zeile Blindtext, ihr Name war Lorem Ipsum, hinaus zu gehen in die weite Grammatik. Der große Oxmox riet ihr davon ab, da es dort wimmele von bösen Kommata, wilden Fragezeichen und hinterhältigen Semikoli, doch das Blindtextchen ließ sich nicht beirren. Es packte seine sieben Versalien, schob sich sein Initial in den Gürtel und machte sich auf den Weg. Als es die ersten Hügel des Kursivgebirges erklommen hatte, warf es einen letzten Blick zurück auf die Skyline seiner Heimatstadt Buchstabhausen, die Headline von Alphabetdorf und die Subline seiner eigenen Straße, der Zeilengasse. Wehmütig lief ihm eine rhetorische Frage über die Wange, dann setzte es seinen Weg fort. Unterwegs traf es eine Copy. Die Copy warnte das Blindtextchen, da, wo sie herkäme wäre sie zigmal umgeschrieben worden und alles, was von ihrem Ursprung noch übrig wäre, sei das Wort..."; // Quelle: http://www.blindtextgenerator.de/
   }
   Console.WriteLine("Erzeuge Flüge...");
   var Passagiere = from p in db.Passagier select p;
   System.Random rnd = new Random();
   var Fluege = from f in db.Flug select f;
   int Start = 100;

   for (int i = Start; i < (Start + ANZFluege); i++)
   {

    if (i % 100 == 0) Console.WriteLine(i);
    de.WWWings.Test.Modelle.EF6.Flug FlugNeu = new de.WWWings.Test.Modelle.EF6.Flug();
    FlugNeu.FlugNr = i;
    FlugNeu.Abflugort = Flughaefen[rnd.Next(0, Flughaefen.Length - 1)];
    FlugNeu.Zielort = Flughaefen[rnd.Next(0, Flughaefen.Length - 1)]; ;
    if (FlugNeu.Abflugort == FlugNeu.Zielort) { i--; continue; } // Keine Rundflüge!
    FlugNeu.FreiePlaetze = Convert.ToInt16(new System.Random(i).Next(250));
    FlugNeu.Plaetze = 250;
    var dat = DateTime.Now.AddDays((double)FlugNeu.FreiePlaetze).AddMinutes((double)FlugNeu.FreiePlaetze * 7);

    dat = dat.Subtract(new TimeSpan(0, 0, 0, dat.Second, 0));
    FlugNeu.Datum = dat;
    FlugNeu.Ankunft = FlugNeu.Datum.AddMinutes(Convert.ToInt16(new System.Random(i).Next(4*60)));
    FlugNeu.NichtRaucherFlug = true;
   // FlugNeu.Memo = Memo;

    db.Flug.AddObject(FlugNeu);
    try
    {
     db.SaveChanges();
    }
    catch (Exception ex)
    {
     Console.WriteLine("   " + FlugNeu.FlugNr + ":" + FlugNeu.Abflugort + " -> " + FlugNeu.Zielort + ": " + ex.ToString() );

    }

   }
   Console.WriteLine("Flüge nach dem Einfügen: " + db.Flug.Count());
   return rnd;
  }

  private static void Init_Buchungen( de.WWWings.Test.Modelle.EF6.WWWings6Entities  db)
  {
   int k = 0;
   System.Random rnd5 = new Random();
   Console.WriteLine("Erzeuge Buchungen...");
   var Fluege2 = from f in db.Flug select f;

   Passagier[] PassagierArray = db.Passagier.ToArray();
   foreach (Flug f in Fluege2.ToList())
   {
    k++;
    if (k % 100 == 0) Console.WriteLine(k);

    for (int j = 1; j < ANZBuchungenProFlug; j++)
    {
     Random rnd2 = new System.Random(System.DateTime.Now.Millisecond);
     // Wähle Zufällig einen Passagier
     Passagier p = PassagierArray[Convert.ToInt16(rnd5.Next(PassagierArray.Count()))];
     Console.WriteLine(f.FlugNr + " ->  " + p.PersonID);
     // Buchung anlegen
     f.Passagier.Add(p);

     try // Weil doppelte möglich sind durch Zufallsauswahl!
     {
      db.SaveChanges();
     }
     catch (Exception ex)
     {
      Console.WriteLine(ex.InnerException.Message);
      f.Passagier.Remove(p);
     }
    }

    

   }
  }

  private static void Init_PilotenZuFluegen( de.WWWings.Test.Modelle.EF6.WWWings6Entities  db)
  {
   Pilot[] Piloten = db.Pilot.ToArray();
   System.Random rnd4 = new Random();
   Console.WriteLine("Piloten zu Flügen...");
   foreach (Flug f in db.Flug)
   {
    f.Pilot_PersonID = Piloten[rnd4.Next(db.Pilot.Count() - 1)].PersonID;
   }
   db.SaveChanges();
   Console.WriteLine("Piloten zugeordnet für Flüge!");
  }

  private static void Init_Piloten( de.WWWings.Test.Modelle.EF6.WWWings6Entities  db)
  {
   Console.WriteLine("Erzeuge Piloten...");
   System.Random rnd3 = new Random();
   // Alle Mitarbeiter > 250 werden zu Mitarbeitern
   foreach (Person p in db.Person.Where(pe => pe.PersonID >= (ANZPass *0.75)))
   {
    Pilot pi = new Pilot();
    pi.PersonID = p.PersonID;
    pi.FlugscheinSeit = DateTime.Now.AddDays(-rnd3.Next(2000));
    pi.Flugscheintyp = "A";
    pi.Flugschule = "Essen";
    pi.Flugstunden = rnd3.Next(5000);
    db.Pilot.AddObject(pi);
   }
   db.SaveChanges();
   Console.WriteLine("Piloten nach dem Einfügen: " + db.Pilot.Count());
  }

  private static void Init_Mitarbeiter( de.WWWings.Test.Modelle.EF6.WWWings6Entities  db)
  {
   Person ErstePerson = null;
   Console.WriteLine("Erzeuge Mitarbeiter...");
   System.Random rnd2 = new Random();
   // Alle Personen > 200 werden zu Mitarbeitern
   foreach (Person p in db.Person.Where(pe => pe.PersonID >= (ANZPass/2)).ToList())
   {
    if (ErstePerson == null) ErstePerson = p;
    Mitarbeiter mi = new Mitarbeiter();
    mi.PersonID = p.PersonID;
    mi.Einstellungsdatum = DateTime.Now.AddDays(-rnd2.Next(1000));
    mi.VorgesetzterPersonID = ErstePerson.PersonID;
    mi.MitarbeiterNr = p.PersonID;
    db.Mitarbeiter.AddObject(mi);
    db.SaveChanges();

   }
   Console.WriteLine("Mitarbeiter nach dem Einfügen: " + db.Mitarbeiter.Count());
  }

  private static void Init_Passagiere( de.WWWings.Test.Modelle.EF6.WWWings6Entities  db)
  {
   // Passagiere Anlegen
   Console.WriteLine("Erzeuge Passagiere...");
   // Quelle: http://de.wikipedia.org/wiki/Liste_der_h%C3%A4ufigsten_Familiennamen_in_Deutschland

   string[] Nachnamen = { "Müller", "Schmidt", "Schneider", "Fischer", "Weber", "Meyer", "Wagner", "Becker", "Schulz", "Hoffmann", "Schäfer", "Koch", "Bauer", "Richter", "Klein", "Wolf", "Schröder", "Neumann", "Schwarz", "Zimmermann" };
   // Quelle: http://www.beliebte-vornamen.de/3467-alle-spitzenreiter.htm

   string[] Vornamen = { "Leon", "Hannah", "Lukas", "Anna", "Leonie", "Marie", "Niklas", "Sarah", "Jan", "Laura", "Julia", "Lisa", "Kevin" };


   // oder: Politiker-Namenskarusell :-)
   //string[] Nachnamen = { "Gysi", "Stoiber", "Koch", "Steinmeyer", "Schröder", "Merkel", "Westerwelle", "Beck", "Lafontaine", "Trittin", "Roth" };
   //string[] Vornamen = { "Edmund", "Olaf", "Roland", "Gerhard", "Angela", "Joschka", "Guido", "Gregor", "Kurt", "Frank-Walter", "Oskar", "Jürgen", "Claudia" };
   System.Random rnd2 = new Random();


   //DBUtil.ClearTable("GF_GebuchteFluege");
   //DBUtil.ClearTable("Passagier");


   string[] Staedte = { "Berlin", "Hamburg", "München", "Köln", "Frankfurt", "Stuttgart", "Dortmund", "Essen", "Düsseldorf", "Bremen", "Hannover", "Leipzig", "Dresden", "Nürnberg", "Duisburg", "Bochum", "Wuppertal", "Bielefeld", "Bonn", "Mannheim" };
   string[] KundenStatus = { "A", "B", "C" };

   for (int PNummer = 1; PNummer <= ANZPass; PNummer++)
   {
    string Vorname = Vornamen[rnd2.Next(0, Vornamen.Length - 1)]; ;
    string Nachname = Nachnamen[rnd2.Next(0, Vornamen.Length - 1)]; ;
    Person pe = new Person();
    pe.Name = Nachname;
    pe.Vorname = Vorname;
    pe.Geburtstag = new DateTime(1940, 1, 1).AddDays(Convert.ToInt32(new Random(DateTime.Now.Millisecond).Next(20000)));
    pe.PersonID = PNummer;
    pe.Land = "DE";
    pe.Stadt = Staedte[rnd2.Next(0, Staedte.Length - 1)];
    pe.EMail = Vorname.Substring(0, 1) + "." + Nachname + "@world-wide-wings.de";
    db.Person.AddObject(pe);

    if (PNummer < (ANZPass / 2))
    {
     Passagier ps = new Passagier();
     ps.PersonID = PNummer;
     ps.KundeSeit = pe.Geburtstag.Value.AddHours(Convert.ToInt32(new Random(DateTime.Now.Millisecond).Next(5000)));
     ps.KundenStatus = KundenStatus[rnd2.Next(2)];
     db.Passagier.AddObject(ps);
    }

    db.SaveChanges();

    System.Console.WriteLine(PNummer + ": " + Vorname + " " + Nachname);

   }
   Console.WriteLine("Passagiere nach dem Anfügen: " + db.Passagier.Count<Passagier>());
  }

 }
}
