﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;
using de.WWWings.Test.Modelle.EF4;
using de.WWWings.Test.LINQ;


namespace de.WWWings.Test
{
 class EF
 {
  public static void run()
  {

   Demo();
   //Demo_Flüge_Filter_MethodSyntax();

  }

  // --------------------------------------------------------------------

  public static void Print(IDictionary<string, int> gruppe, string s)
  {

      Util.HeadLine(s);
   foreach (var x in gruppe)
   {
    Console.WriteLine(x.Key + ": " + x.Value);
   }

  }


  public static void Print(IEnumerable<FL_Fluege> Fluege, string s)
  {
      Util.HeadLine(s);
   foreach (FL_Fluege x in Fluege)
   {
    PrintFL_Fluege(x);
   }
  }

  public static void Print(IEnumerable<PS_Passagier> Fluege, string s)
  {
      Util.HeadLine(s);
   foreach (PS_Passagier x in Fluege)
   {
    PrintPS_Passagier(x);
   }
  }

  public static void Print(IEnumerable<string> Fluege, string s)
  {
      Util.HeadLine(s);
   foreach (string x in Fluege)
   {
    Console.WriteLine(x);
   }
  }


  public static void Print(IEnumerable<IGrouping<string, FL_Fluege>> Gruppen, string s)
  {
      Util.HeadLine(s);
   foreach (IGrouping<string, FL_Fluege> x in Gruppen)
   {
    Console.WriteLine("---- " + x.Key);
    foreach (FL_Fluege y in x)
    {
     PrintFL_Fluege(y);
    }
   }
  }

  public static void Print(FL_Fluege x, string s)
  {
      Util.HeadLine(s);
   if (x == null) { Console.WriteLine("---"); return; }
   PrintFL_Fluege(x);

  }

  public static void PrintFL_Fluege(FL_Fluege x)
  {
   Console.WriteLine(x.FL_FlugNr + ": " + x.FL_Abflugort + " -> " + x.FL_Zielort + ": " + x.FL_FreiePlaetze + " freie Plätze");
  }

  public static void PrintPS_Passagier(PS_Passagier x)
  {


   Console.WriteLine(x.PE_Person.PE_Name + ": " + x.PE_Person.PE_Geburtstag + " -> " + x.GF_GebuchteFluege.Count);
  }


  public static void Print(object x, string s)
  {
      Util.HeadLine(s);

   Console.WriteLine(x);

  }




  //private static void Print(IEnumerable<int> Fluege, string s)
  //{
  // Console.ForegroundColor = ConsoleColor.Yellow;
  // Console.WriteLine(s);
  // Console.ForegroundColor = ConsoleColor.Gray;
  // foreach (var x in Fluege)
  // {
  //  Console.WriteLine(x);
  // }
  //}

  
  private static void Demo()
  {

   de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();


   // Initialisiere das Objektmodell

   string s;
   long i;
   int? i2;
   de.WWWings.Test.Modelle.EF4.FL_Fluege flug;
   double? d2;

   s = "Geben Sie alle Flüge von Rom aus!";

   var Ergebnis =
    from f in db.FL_Fluege
    where f.FL_Abflugort == "Rom"
    select f;

   Print(Ergebnis, s);

   s = "Geben Sie alle Flüge aus, die weniger als 100 freie Plätze haben.";
   Ergebnis =
      from n in db.FL_Fluege
      where n.FL_FreiePlaetze < 100
      select n;
   Print(Ergebnis, s);

   s = "Geben Sie alle Flüge aus, die weniger als 100 freie Plätze haben. Sortieren Sie die Liste aufsteigend nach Platzanzahl.";
   Ergebnis =
   from n in db.FL_Fluege
   where n.FL_FreiePlaetze < 100
   orderby n.FL_FreiePlaetze
   select n;
   Print(Ergebnis, s);


   s = "Geben Sie alle Flüge aus, die weniger als 100 freie Plätze haben. Sortieren Sie die Liste absteigend nach Platzanzahl.";
   Ergebnis =
   from n in db.FL_Fluege
   where n.FL_FreiePlaetze < 100
   orderby n.FL_FreiePlaetze descending
   select n;



   Print(Ergebnis, s);

   s = "Geben Sie Flug 101 aus.";
   flug = (from f in db.FL_Fluege
           where f.FL_FlugNr == 101
           select f).FirstOrDefault();
   Print(flug, s);


   s = "Geben die Routen (von x nach y aus), aber jede Route nur einmal!";
   var Strecken =
        (from n in db.FL_Fluege
         select new { n.FL_Abflugort, n.FL_Zielort }).Distinct();
   Util.HeadLine(s);

   foreach (var f in Strecken)
   {
    Console.WriteLine(f.FL_Abflugort + " -> " + f.FL_Zielort);
   }


   s = "Geben Sie alle Ziele aus, die von Rom erreichbar sind.";
   var Ziele =
        (from n in db.FL_Fluege
         where n.FL_Abflugort == "Rom"
         select n.FL_Zielort).Distinct();
   Util.HeadLine(s);

   foreach (string f in Ziele)
   {
    Console.WriteLine(f);
   }

   s = "Geben Sie den vierten bis achten FL_Fluege aus in der nach freien Plätzen aufsteigend sortierten Liste aller Flüge, die in Berlin landen.";
   Ergebnis =
       (from n in db.FL_Fluege
        where n.FL_Zielort == "Berlin"
        orderby n.FL_FreiePlaetze
        select n).Skip(3).Take(4);
   Print(Ergebnis, s);

   s = "Geben Sie den ersten FL_Fluege aus in der nach freien Plätzen aufsteigend sortierten Liste aller Flüge, die in Berlin landen.";
   flug =
      (from n in db.FL_Fluege
       where n.FL_Zielort == "Berlin"
       orderby n.FL_FreiePlaetze
       select n).First();
   Print(flug, s);

   // "Last" not supported in LTE!
   s = "Geben Sie den letzten FL_Fluege aus in der nach freien Plätzen aufsteigend sortierten Liste aller Flüge, die in Berlin landen.";
   //flug =
   //   (from n in db.FL_Fluege
   //    where n.FL_Zielort == "Berlin"
   //    orderby n.FL_FreiePlaetze
   //    select n).Last();
   //Print(flug, s);

   // "ElementAr" not supported in LTE!
   s = "Geben Sie den 10. FL_Fluege aus in der nach freien Plätzen aufsteigend sortierten Liste aller Flüge, die in Berlin landen.";
   //flug =
   //   (from n in db.FL_Fluege
   //    where n.FL_Zielort == "Berlin"
   //    orderby n.FL_FreiePlaetze
   //    select n).ElementAt(9);
   //Print(flug, s);

   //s = "Geben Sie den 150. FL_Fluege aus in der nach freien Plätzen aufsteigend sortierten Liste aller Flüge, die in Berlin landen.";
   //flug =
   //   (from n in db.FL_Fluege
   //    where n.FL_Zielort == "Berlin"
   //    orderby n.FL_FreiePlaetze
   //    select n).ElementAtOrDefault(149);
   //Print(flug, s);

   s = "Geben Sie Anzahl der Flüge aus (mit einem LINQ-Statement!)";
   i =
      (from n in db.FL_Fluege
       select n).Count();
   Print(i, s);


   s = "Geben Sie geringste freie Platzzahl aus.";
   i2 =
      (from n in db.FL_Fluege
       select n).Min(n => n.FL_FreiePlaetze);
   Print(i2, s);

   s = "Geben Sie höchste freie Platzzahl aus.";
   i2 =
      (from n in db.FL_Fluege
       select n).Min(n => n.FL_FreiePlaetze);
   Print(i2, s);

   s = "Geben Sie durchschnittliche freie Platzzahl aus.";
   d2 =
      (from n in db.FL_Fluege
       select n).Average(n => n.FL_FreiePlaetze);
   Print(d2, s);

   s = "Geben Sie Summe aller freien Plätze aus.";
   i2 =
      (from n in db.FL_Fluege
       select n).Sum(n => n.FL_FreiePlaetze);
   Print(i, s);

   s = "Gruppieren Sie die Flüge nach FL_Abflugorten.";
   IEnumerable<IGrouping<string, FL_Fluege>> GruppeErgebnis =
       (from n in db.FL_Fluege
        group n by n.FL_Abflugort);
   Print(GruppeErgebnis, s);

   s = "Geben Sie die Häufigkeit eines jeden FL_Abflugortes aus!";
   IDictionary<string, int> GruppeHaeufigkeit =
         (from n in db.FL_Fluege
          group n by n.FL_Abflugort into g
          select new { Name = g.Key, AnzFL_Fluege = g.Count() }
          ).ToDictionary(y => y.Name, y => y.AnzFL_Fluege);
   Print(GruppeHaeufigkeit, s);

   s = "Geben Sie zu jedem Flug die Anzahl der Buchungen aus";
  var FlugAnzahl =
         (from n in db.FL_Fluege
          select n);
  Util.HeadLine(s);
   foreach(FL_Fluege f in FlugAnzahl)
   {
    Console.Write(f.FL_FlugNr + " = " + f.GF_GebuchteFluege.Count());
   }

   s = "Geben Sie zu jeder Buchung die Details aus!";
   var Buchungen =
          (from b in db.GF_GebuchteFluege.Include("PS_Passagier")
           select b);
   Util.HeadLine(s);
   foreach (GF_GebuchteFluege b in Buchungen)
   {
    Console.Write(b.GF_Buchungscode + ": für Flug " + b.FL_Fluege.FL_FlugNr + " für Passagier " + b.PS_Passagier.PS_ID);
   }


   s = "Geben Sie die Daten von dem Passagier mit der ID 1 aus!";
   PS_Passagier pass = (from p in db.PS_Passagier.Include("PE_Person")
                        orderby p.PE_Person.PE_Name
                        where p.PS_ID == 2727
                        select p).FirstOrDefault();

   Console.WriteLine(pass.PS_ID + ": " + pass.PE_Person.PE_Name);

   s = "Erstellen Sie eine gruppierte Liste aller Passagiere mit Ihren Buchungen!";
   var pass2 = from p in db.PS_Passagier
               orderby p.PE_Person.PE_Name
               select new { p.PE_Person.PE_Name, p.GF_GebuchteFluege };
   foreach (var p in pass2)
   {
    Console.WriteLine(p.PE_Name);
    foreach (GF_GebuchteFluege b in p.GF_GebuchteFluege)
     Console.WriteLine("\t" + b.GF_Buchungscode);
   }

   s = "Erstellen Sie die Liste der 10 Passagiere mit den meisten Buchungen.";
   var pass4 = (from p in db.PS_Passagier
               orderby p.GF_GebuchteFluege.Count descending
               select p).Take(10);
   Print(pass4, s);


   s = "Geben Sie den/die Passagier(e) mit den meisten Buchungen aus.";
   pass4 = (from n in db.PS_Passagier where n.GF_GebuchteFluege.Count == db.PS_Passagier.Max(x => x.GF_GebuchteFluege.Count) select n);
   Print(pass4, s);


   s = "Finden Sie alle Passagiere, die nach Rom fliegen.";

   pass4 = (from p in db.PS_Passagier
           where p.GF_GebuchteFluege.Any(b => b.FL_Fluege.FL_Zielort == "Rom")
           select p);
   Print(pass4, s);


   s = "Finden Sie alle PS_Passagiere, die genauso viele Buchungen haben wie ein FL_Fluege freie Plätze.";
   var joinpass = (from p in db.PS_Passagier
                   join f in db.FL_Fluege
                   on p.GF_GebuchteFluege.Count equals f.FL_FreiePlaetze
                   select new { p.PE_Person.PE_Name, f.FL_FlugNr, p.GF_GebuchteFluege.Count, f.FL_FreiePlaetze });
   Util.HeadLine(s);
   foreach (var j in joinpass)
   {
    Console.WriteLine(j.PE_Name + " und FL_Fluege " + j.FL_FlugNr + " haben die gleiche Zahl: " + j.Count + " / " + j.FL_FreiePlaetze);
   }


   s = "Geben Sie alle Passagiere aus und optional dazu einen FL_Fluege, der genausoviele freie Plätze hat wie der Passagier Buchungen hat.";
   var joinpass2 = (from p in db.PS_Passagier
                    join f in db.FL_Fluege
                    on p.GF_GebuchteFluege.Count equals f.FL_FreiePlaetze
                    into Fluege
                    select new { p.PE_Person.PE_Name, Fluege });
   Util.HeadLine(s);
   foreach (var j in joinpass2)
   {
    Console.WriteLine(j.PE_Name + " hat " + j.Fluege.Count() + " korrespondierende Flüge!");
   }

   s = "Geben Sie alle PS_Passagiere, die älter als 50 Jahre sind!";

   pass4 =
                  (from p in db.PS_Passagier
                   where p.PE_Person.PE_Geburtstag.Value.AddYears(50) < DateTime.Now
                   select p);

   //db.Log = Console.Out;
   Print(pass4, s);


   s = "Geben Sie alle Flüge aus, mit PS_Passagieren älter als 50 Jahre !";

   Ergebnis =
                  (from p in db.PS_Passagier
                   where p.PE_Person.PE_Geburtstag.Value.AddYears(50) < DateTime.Now
                   from b in p.GF_GebuchteFluege
                   select b.FL_Fluege).Distinct();
   // Kontrolle:
   //foreach (FL_Fluege f in Ergebnis)
   //{
   // foreach (PS_Passagier p in f.PS_Passagiere)
   // {
   //  Console.WriteLine(p.Geburtsdatum);
   // }
   //}
   Print(Ergebnis, s);




  }






 }
}
