﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Data.EntityClient;
using System.Data.Metadata.Edm;
using System.Data.Objects;
using System.Data.SqlClient;
using System.Diagnostics;
using System.Linq;
using System.Linq.Expressions;
using GO = de.WWWings.Test.Modelle.EF6;
using ITVisions;
using VerschiedeneDemos_CS.FCL3;
using System.Linq.Dynamic;

namespace de.WWWings.Test.Demos_EF
{
 public class EF_DynamischeQueries
 {
  //  /// <summary>
  //  /// Dynamische Abfragen
  //  /// </summary>
  //  public static void EF_Dyn_Query()
  //  {
  //   de.WWWings.Test.Modelle.EF6.WWWings6Entities db = new de.WWWings.Test.Modelle.EF6.WWWings6Entities();


  //   // LINQ-Befehl in Abfragesyntax
  //   var Q1 = from f in db.Flug where f.Abflugort == "Rom" select f;

  //   // LINQ-Befehl in Methodensyntax
  //   var Q2 = (from f in db.Flug select f).Where(f => f.Abflugort == "Rom");

  //   // Zusammenbauen von LINQ-Befehlen mit der LINQ-Methodensyntax
  //   IEnumerable<Flug> Q3 = (from f in db.Flug select f).Where(f => f.Abflugort == "Rom");
  //   Boolean b = false;
  //   if (b)
  //   {
  //    Q3 = Q3.Where(f => f.Zielort == "Berlin");
  //   }

  //   // Query Builder Methods mit anonymen Typ
  //   ObjectQuery<DbDataRecord> Q5 =
  //db.Flug.Where("it.Abflugort = 'Rom'").Select("it.AbflugOrt,it.Zielort");

  //   // Query Builder Methods über zwei Tabellen mit 1:n-Beziehung
  //   ObjectQuery<Flug> Q4 =
  //db.Flug.Where("it.FreiePlaetze > 0 and anyelement(it.GF_GebuchteFlug).GF_Preis > 100");

  //   // Query Builder Methods über zwei Tabellen mit 1:1-Beziehung
  //   ObjectQuery<GF_GebuchteFlug> Q6 =
  //db.GF_GebuchteFlug.Where("it.GF_Preis < 100 and it.Flug.Abflugort = 'Berlin'");

  //   // Query Builder Methods über frei Tabellen mit 1:n- und 1:1-Beziehung
  //   ObjectQuery<Flug> Q7 =
  //db.Flug.Where("it.FreiePlaetze > 0 and set(it.GF_GebuchteFlug).GF_Preis > 100 and anyelement(it.GF_GebuchteFlug).PS_Passagier.PS_ID < 100");

  //   // äquivalenter LINQ-Befehl zum Prüfen, welchen ESQL-Befehl das EF erzeugt
  //   var Q8 = from f in db.Flug where f.FreiePlaetze > 0 && f.GF_GebuchteFlug.All(g => g.GF_Preis > 100) && f.GF_GebuchteFlug.Any(g => g.PS_Passagier.PS_ID < 100) select new { f.FlugNr, f.GF_GebuchteFlug };

  //   Console.WriteLine(((ObjectQuery)Q8).ToTraceString());






  //   foreach (var f in Q8)
  //   {
  //    Console.WriteLine("Flug Nr {0}!", f.FlugNr);
  //   }


  //   // ESQL

  //   //foreach (Flug f in Q8)
  //   //{
  //   // Console.WriteLine("Flug Nr {0} von {1} nach {2} hat {3} freie Plätze!", f.FlugNr, f.Abflugort, f.Zielort, f.FreiePlaetze);
  //   // Console.WriteLine("ALT: " + f.FlugNr + " = " + f.FreiePlaetze);
  //   // f.FreiePlaetze--;
  //   // Console.WriteLine("NEU: " + f.FlugNr + " = " + f.FreiePlaetze);
  //   //}

  //   db.SaveChanges();
  //   db.Dispose();
  //  }


  /// <summary>
  /// Beispiel LINQ-Abfrage mit Bedingungen
  /// </summary>
  public static void EF_DynQuery_LINQBedingt()
  {
   // Eingabedaten   // Eingabedaten
   string Zielort = "Rom";
   short? MindestzahlFreierPlaetze = 10;

   // EF Modell
   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx = new de.WWWings.Test.Modelle.EF6.WWWings6Entities();


   // Basismenge
   IQueryable<GO.Flug> abfrage = from flug in ctx.Flug
                                 where
                                  flug.FlugNr < 300
                                  && ((string.IsNullOrEmpty(Zielort)) || (!string.IsNullOrEmpty(Zielort) && flug.Zielort == Zielort))
                                  && ((MindestzahlFreierPlaetze <= 0) || ((MindestzahlFreierPlaetze > 0) && flug.FreiePlaetze > MindestzahlFreierPlaetze))
                                 select flug;

   // Zum Test
   Console.WriteLine("Resultierender SQL-Befehl:\n" + ((ObjectQuery)abfrage).ToTraceString());

   // Ausgabe der Ergebnismenge
   Console.WriteLine("\nGefundene Flüge:");
   foreach (GO.Flug Flug in abfrage.ToList())
   {
    Console.WriteLine("Flug Nr {0} von {1} nach {2}!", Flug.FlugNr, Flug.Abflugort, Flug.Zielort);
   }

  }

  /// <summary>
  /// Beispiel für den den schrittweisen Zusammenbau von LINQ-Abfragen
  /// </summary>
  public static void EF_DynQuery_LINQZusammenbau()
  {
   // Eingabedaten   // Eingabedaten
   string Zielort = "Rom";
   short? MindestzahlFreierPlaetze = 10;

   // EF Modell
   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx = new de.WWWings.Test.Modelle.EF6.WWWings6Entities();

   // Basismenge
   IQueryable<GO.Flug> abfrage = from flug in ctx.Flug where flug.FlugNr < 300 select flug;

   // Zum Test
   Console.WriteLine("Resultierender SQL-Befehl vorher:\n" + ((ObjectQuery)abfrage).ToTraceString());

   if (!string.IsNullOrEmpty(Zielort)) abfrage = from flug in abfrage where flug.Zielort == Zielort select flug;
   if (MindestzahlFreierPlaetze > 0) abfrage = from flug in abfrage where flug.FreiePlaetze > MindestzahlFreierPlaetze select flug;

   // Zum Test
   Console.WriteLine("\nResultierender SQL-Befehl nachher:\n" + ((ObjectQuery)abfrage).ToTraceString());

   // Ausgabe der Ergebnismenge
   Console.WriteLine("\nGefundene Flüge:");
   foreach (GO.Flug Flug in abfrage.ToList())
   {
    Console.WriteLine("Flug Nr {0} von {1} nach {2}!", Flug.FlugNr, Flug.Abflugort, Flug.Zielort);
   }

  }


  /// <summary>
  /// Beispiel für den Einsatz von Expression Trees zur Modifikation einer bestehenden LINQ-to-Entities-Abfrage
  /// </summary>
  public static void EF_Dyn_Query_ExpressionTree_Einfach()
  {
   // Eingabedaten   // Eingabedaten
   string Zielort = "Rom";
   short? MindestzahlFreierPlaetze = 10;

   // EF Modell
   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx = new de.WWWings.Test.Modelle.EF6.WWWings6Entities();

   // Basismenge
   IQueryable<GO.Flug> abfrage = from flug in ctx.Flug where flug.FlugNr < 300 select flug;

   // Zum Test
   Console.WriteLine("Resultierender SQL-Befehl vorher:\n" + ((ObjectQuery)abfrage).ToTraceString());

   if (!String.IsNullOrEmpty(Zielort) && MindestzahlFreierPlaetze > 0)
   {

    // Laufvariable definieren
    ParameterExpression f = Expression.Parameter(typeof(GO.Flug), "f");

    // Bedingung 1 festlegen
    Expression left = Expression.Property(f, "Zielort");
    Expression right = Expression.Constant(Zielort);
    Expression Bed1 = Expression.Equal(left, right);

    // Bedingung 2 festlegen
    left = Expression.Property(f, "FreiePlaetze");
    right = Expression.Constant((short?)MindestzahlFreierPlaetze, typeof(short?));
    Expression Bed2 = Expression.GreaterThan(left, right);

    // Verbinden beider Bedingungen mit And
    Expression predicateBody = Expression.And(Bed1, Bed2);

    // Expression Tree aus beiden Bedingungen
    MethodCallExpression whereCallExpression = Expression.Call(
        typeof(Queryable),
        "Where",
        new Type[] { abfrage.ElementType },
        abfrage.Expression,
        Expression.Lambda<Func<GO.Flug, bool>>(predicateBody, new ParameterExpression[] { f }));

    // Umwandeln des Expression Tree in eine Abfrage
    abfrage = abfrage.Provider.CreateQuery<GO.Flug>(whereCallExpression);

    // Zum Test
    Console.WriteLine("\nResultierender SQL-Befehl nachher:\n" + ((ObjectQuery)abfrage).ToTraceString());
   }

   // Ausgabe der Ergebnismenge
   Console.WriteLine("\nGefundene Flüge:");
   foreach (GO.Flug Flug in abfrage.ToList())
   {
    Console.WriteLine("Flug Nr {0} von {1} nach {2}: {3} freie Plätze!", Flug.FlugNr, Flug.Abflugort, Flug.Zielort, Flug.FreiePlaetze);
   }

   ctx.Dispose();
  }

  /// <summary>
  /// Beispiel für den Einsatz von Expression Trees zur Modifikation 
  /// einer bestehenden LINQ-to-Entities-Abfrage
  /// am Beispiel einer WHERE-Bedingung mit einer variablen Anzahl von Bedingungen
  /// Hintergrund: Ein Benutzer hat auf dem Bildschirm eine variable Anzahl von Filtern
  /// Annahme, um das Beispiel prägnant zu halten: Es wird immer auf Gleichzeit geprüft
  /// </summary>
  public static void EF_Dyn_Query_ExpressionTree_Variabel()
  {

   // Eingabedaten
   var Filter = new SortedDictionary<string, object>() { { "Abflugort", "Rom" }, { "Zielort", "Berlin" }, { "NichtRaucherFlug", true } };
   string Sortierung = "FreiePlaetze";

   // EF Modell
   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx = new de.WWWings.Test.Modelle.EF6.WWWings6Entities();

   // Basismenge
   var Q_Vorlaeufig = from flug in ctx.Flug select flug;

   // Zum Test
   Console.WriteLine("\nResultierender SQL-Befehl vorher:\n: " + ((ObjectQuery)Q_Vorlaeufig).ToTraceString());
   // Laufvariable definieren
   ParameterExpression f = Expression.Parameter(typeof(GO.Flug), "f");

   Expression GesamtBedingung = null;
   foreach (var filter in Filter)
   {
    // Bedingung festlegen
    Expression left = Expression.Property(f, filter.Key);
    Expression right = Expression.Constant(filter.Value);
    Expression Bed = Expression.Equal(left, right);
    // Verknpüfen mit den bisherigen Bedingungen
    if (GesamtBedingung == null) GesamtBedingung = Bed;
    else GesamtBedingung = Expression.And(GesamtBedingung, Bed); // hier: "UND"
   }

   // Expression Tree aus allen Bedingungen
   MethodCallExpression whereCallExpression = Expression.Call(
       typeof(Queryable),
       "Where",
       new Type[] { Q_Vorlaeufig.ElementType },
       Q_Vorlaeufig.Expression,
       Expression.Lambda<Func<GO.Flug, bool>>(GesamtBedingung, new ParameterExpression[] { f }));

   // Umwandeln des Expression Tree in eine Abfrage
   var Q_Endgueltig = Q_Vorlaeufig.Provider.CreateQuery<GO.Flug>(whereCallExpression);

   // Sortierung

   //var body = Expression.PropertyOrField(f, Sortierung);

   //var sortExpression = Expression.Lambda(body, f); 


   //MethodCallExpression orderByCallExpression = Expression.Call(
   //     typeof(IQueryable<GO.Flug>),
   //     "OrderBy",
   //     new Type[] { Q_Vorlaeufig.ElementType, Q_Vorlaeufig.ElementType },
   //     Q_Endgueltig.Expression, sortExpression
   //     );

   // Q_Endgueltig = Q_Endgueltig.Provider.CreateQuery<GO.Flug>(orderByCallExpression);

   // Zum Test
   Console.WriteLine("\nResultierender SQL-Befehl nachher:\n: " + ((ObjectQuery)Q_Endgueltig).ToTraceString());

   // Ausgabe der Ergebnismenge
   Console.WriteLine("\nGefundene Flüge:");
   foreach (var Flug in Q_Endgueltig)
   {
    Console.WriteLine("Flug Nr {0} von {1} nach {2}: {3} freie Plätze!", Flug.FlugNr, Flug.Abflugort, Flug.Zielort, Flug.FreiePlaetze);
   }

   ctx.Dispose();
  }


  /// <summary>
  /// Beispiel für den Einsatz von Query Builder Methods zur Modifikation 
  /// einer bestehenden LINQ-to-Entities-Abfrage
  /// am Beispiel einer WHERE-Bedingung mit einer variablen Anzahl von Bedingungen
  /// Hintergrund: Ein Benutzer hat auf dem Bildschirm eine variable Anzahl von Filtern
  /// Annahme, um das Beispiel prägnant zu halten: Es wird immer auf Gleichzeit geprüft
  /// </summary>
  public static void EF_Dyn_Query_QueryBuilderMethods()
  {

   // Eingabedaten
   var Filter = new SortedDictionary<string, object>() { { "Abflugort", "Rom" }, { "Zielort", "Berlin" }, { "NichtRaucherFlug", true } };
   string Sortierung = "FreiePlaetze desc";
   // EF Modell
   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx = new de.WWWings.Test.Modelle.EF6.WWWings6Entities();

   // Basismenge
   IQueryable<GO.Flug> Q_Vorlaeufig = ctx.Flug; // geht hier nicht: from flug in ctx.Flug where flug.FlugNr < 300 select flug;

   // Zum Test
   Console.WriteLine("\nResultierender SQL-Befehl vorher:\n: " + ((ObjectQuery)Q_Vorlaeufig).ToTraceString());

   string bedingungen = "";
   foreach (var filter in Filter)
   {
    Console.WriteLine(filter.Value.GetType().Name);
    switch (filter.Value.GetType().Name)
    {
     case "String":
      bedingungen += (bedingungen != "" ? " and " : "") + "it." + filter.Key + " = '" + filter.Value + "'"; break;
     default:
      bedingungen += (bedingungen != "" ? " and " : "") + "it." + filter.Key + " = " + filter.Value + ""; break;
    }
   }

   // Modfikation der Abfrage
   ObjectQuery<GO.Flug> Q_endgueltig = ((ObjectQuery<GO.Flug>)Q_Vorlaeufig);
   // optional: Q_endgueltig.Name = "f"; // Vergabe des Variablennamens anstelle von "it"

   //  Bedingungen anwenden
   if (!String.IsNullOrEmpty(bedingungen)) Q_endgueltig = Q_endgueltig.Where(bedingungen);

   //  Sortierung anwenden
   if (!String.IsNullOrEmpty(Sortierung)) Q_endgueltig = Q_endgueltig.OrderBy("it." + Sortierung);

   Q_endgueltig = ((ObjectQuery<GO.Flug>)(from x in Q_endgueltig where x.FlugNr > 300 select x));

   // Zum Test
   Console.WriteLine("\nResultierender SQL-Befehl nachher:\n: " + ((ObjectQuery)Q_endgueltig).ToTraceString());

   // Ausgabe der Ergebnismenge
   Console.WriteLine("\nGefundene Flüge:");
   foreach (var Flug in Q_endgueltig)
   {
    Console.WriteLine("Flug Nr {0} von {1} nach {2}: {3} freie Plätze!", Flug.FlugNr, Flug.Abflugort, Flug.Zielort, Flug.FreiePlaetze);
   }

   ctx.Dispose();
  }

  /// <summary>
  /// Beispiel für den Einsatz von Dynamic LINQ zur Modifikation 
  /// einer bestehenden LINQ-to-Entities-Abfrage
  /// am Beispiel einer WHERE-Bedingung mit einer variablen Anzahl von Bedingungen
  /// Hintergrund: Ein Benutzer hat auf dem Bildschirm eine variable Anzahl von Filtern
  /// Annahme, um das Beispiel prägnant zu halten: Es wird immer auf Gleichzeit geprüft
  /// </summary>
  public static void EF_Dyn_Query_DynamicLINQ()
  {

   // Eingabedaten
   var Filter = new SortedDictionary<string, object>() { { "Abflugort", "Rom" }, { "Zielort", "Berlin" }, { "NichtRaucherFlug", true } };
   string Sortierung = "FreiePlaetze desc";

   // EF Modell
   de.WWWings.Test.Modelle.EF6.WWWings6Entities ctx = new de.WWWings.Test.Modelle.EF6.WWWings6Entities();

   // Basismenge
   IQueryable<GO.Flug> abfrage = from flug in ctx.Flug where flug.FlugNr > 300 select flug;

   // Zum Test
   Console.WriteLine("\nResultierender SQL-Befehl vorher:\n: " + ((ObjectQuery)abfrage).ToTraceString());

   // Modfikation der Abfrage

   foreach (var filter in Filter)
   {
    Console.WriteLine(filter.Value.GetType().Name);
    switch (filter.Value.GetType().Name)
    {
     case "String":
      abfrage = abfrage.Where(filter.Key + " = \"" + filter.Value + "\""); break;

     default:
      abfrage = abfrage.Where(filter.Key + " = " + filter.Value); break;
    }
   }

   // optionale Sortierung
   if (!String.IsNullOrEmpty(Sortierung)) abfrage = abfrage.OrderBy(Sortierung);

   // Zum Test
   Console.WriteLine("\nResultierender SQL-Befehl nachher:\n: " + ((ObjectQuery)abfrage).ToTraceString());

   // Ausgabe der Ergebnismenge
   Console.WriteLine("\nGefundene Flüge:");
   foreach (var Flug in abfrage)
   {
    Console.WriteLine("Flug Nr {0} von {1} nach {2}: {3} freie Plätze!", Flug.FlugNr, Flug.Abflugort, Flug.Zielort, Flug.FreiePlaetze);
   }

   ctx.Dispose();
  }


  ///// <summary>
  ///// Beispiel für den Einsatz von Expression Trees zur Modifikation einer bestehenden LINQ-to-Entities-Abfrage
  ///// </summary>
  //public static void EF_Dyn_Query_ExpressionTree_Join()
  //{

  // // EF Modell
  // de.WWWings.Test.Modelle.EF4.WorldWideWings db = new de.WWWings.Test.Modelle.EF4.WorldWideWings();

  // //// Basismenge /Statischer Join/
  // var Q_Ziel = from flug in db.Flug
  //              join buchung in db.GF_GebuchteFlug
  //              on flug.FlugNr equals buchung.GF_FlugNr
  //              where flug.Abflugort == "Berlin" && flug.FlugNr < 200
  //              select flug;

  // Console.WriteLine("ZIEL: " + ((ObjectQuery)Q_Ziel).ToTraceString());

  // var Q_Ziel_Alternativ = from x in (from flug in db.Flug select flug).Join(db.GF_GebuchteFlug, fl => fl.FlugNr, b => b.GF_FlugNr, (fl, b) => fl) where x.Abflugort == "Berlin" && x.FlugNr < 200 select x;

  // Console.WriteLine("ZIEL ALTERNATIV: " + ((ObjectQuery)Q_Ziel_Alternativ).ToTraceString());


  // var Q1 = from flug in db.Flug
  //          select flug;

  // // Zum Test
  // Console.WriteLine("Ausgangszustand: " + ((ObjectQuery)Q1).ToTraceString());

  // // Idee von http://www.eggheadcafe.com/software/aspnet/31733266/linq-join-using-expressio.aspx

  // // OuterKeySelector
  // ParameterExpression TabOuter = Expression.Parameter(typeof(Flug), "flug");
  // Expression TabOuterKey = MemberExpression.Property(TabOuter, "FlugNr");
  // var TabOuterKeys = new ParameterExpression[] { TabOuter };
  // Expression<Func<Flug, int>> OuterKeySelector =
  //  Expression.Lambda<Func<Flug, int>>(TabOuterKey, TabOuterKeys);

  // // InnerKeySelector
  // ParameterExpression TabInner = Expression.Parameter(typeof(Object), "buchung");
  // Expression TabInner2 = MemberExpression.Convert(TabInner,
  // System.Type.GetType("de.WWWings.Test.Modelle.EF4.GF_GebuchteFlug"));
  // Expression TabInnerKey = MemberExpression.Property(TabInner2, "GF_FlugNr");
  // var TabInnerKeys = new ParameterExpression[] { TabInner };
  // Expression<Func<object, int>> InnerKeySelector =
  //  Expression.Lambda<Func<object, int>>(TabInnerKey, TabInnerKeys);

  // //ParameterExpression TabInner = Expression.Parameter(System.Type.GetType("de.WWWings.Test.Modelle.EF4.GF_GebuchteFlug"), "buchung");
  // //Expression TabInnerKey = MemberExpression.Property(TabInner, "GF_FlugNr");
  // //var TabInnerKeys = new ParameterExpression[] { TabInner };
  // //Expression<Func<GF_GebuchteFlug, int>> InnerKeySelector =
  // //Expression.Lambda<Func<GF_GebuchteFlug, int>>(TabInnerKey, TabInnerKeys);

  // ParameterExpression ap1 = Expression.Parameter(typeof(Flug), "flug");
  // ParameterExpression ap2 = Expression.Parameter(System.Type.GetType("de.WWWings.Test.Modelle.EF4.GF_GebuchteFlug"), "buchung");
  // Expression ap3 = ap1;
  // var args3 = new ParameterExpression[] { ap1, ap2 };

  // Expression<Func<Flug, GF_GebuchteFlug, Flug>>
  // ResultSelector = Expression.Lambda<Func<Flug, GF_GebuchteFlug, Flug>>(ap3, args3);

  // // Soweit ganz gut, aber in den generischen Klassen (Func) erscheint immer noch hard-codiert der Typname der zweiten Tabelle (hier: GF_GebuchteFlug). Das müsste eigentlich dynamisch sein. Leider geht GetType() nicht, weil der Typ zur Laufzeit feststehen muss. Wenn man den Typ überall auf "Object" setzt, dann funktioniert Join nicht mehr.
  // //var Q2 = Q1.AsQueryable<Flug>().Join<Flug, GF_GebuchteFlug, int, Flug>(db.GF_GebuchteFlug, OuterKeySelector, InnerKeySelector, ResultSelector);


  // // hier ein Lösungsansatz, wenn alle Typisierungen bei InnerKeySelector und ResultSelector auf Object sind. Leider verweigert Join dann die Arbeit
  // //List<Object> Tabelle2 = new List<object>();
  // //foreach (GF_GebuchteFlug g in db.GF_GebuchteFlug)
  // //{
  // // Tabelle2.Add(g);
  // //}


  // //var Q2 = db.Flug.Join<Flug, object, int, Flug>(Tabelle2, OuterKeySelector, InnerKeySelector, ResultSelector);
  // //var xx = Q2.ToList();
  // var Q2 = Q1;

  // //var query = people.AsQueryable().Join(pets,
  // //                 person => person,
  // //                 pet => pet.Owner,
  // //                 (person, pet) =>
  // //                     new { OwnerName = person.Name, Pet = pet.Name });
  // //Expression Menge = db.GF_GebuchteFlug.AsQueryable().Expression;
  // //MethodCallExpression joinCallExpression = Expression.Call(
  // //    typeof(Queryable),
  // //    "Join", new Type[] { Q1.ElementType, typeof(object), typeof(System.Int32),  typeof(Flug) }, 
  // //         Q1.Expression, Menge, OuterKeySelector, InnerKeySelector, ResultSelector);

  // // Umwandeln des Expression Tree in eine Abfrage
  // //var Q2 = Q1.Provider.CreateQuery<Flug>(joinCallExpression);

  // // Zum Test
  // //Console.WriteLine("Nach Join: " + ((ObjectQuery)Q2).ToTraceString());


  // // Laufvariable definieren
  // ParameterExpression f = Expression.Parameter(typeof(Flug), "f");

  // // Bedingung 1 festlegen
  // Expression left = Expression.Property(f, "Abflugort");
  // Expression right = Expression.Constant("Berlin");
  // Expression Bed1 = Expression.Equal(left, right);

  // // Bedingung 2 festlegen
  // left = Expression.Property(f, "FlugNr");
  // right = Expression.Constant(200, typeof(int));
  // Expression Bed2 = Expression.LessThan(left, right);

  // // Menge aller Bedingungen
  // Expression predicateBody = Expression.And(Bed1, Bed2);

  // // Expression Tree aus beiden Bedingungen
  // MethodCallExpression whereCallExpression = Expression.Call(
  //     typeof(Queryable),
  //     "Where",
  //     new Type[] { Q2.ElementType },
  //     Q2.Expression,
  //     Expression.Lambda<Func<Flug, bool>>(predicateBody, new ParameterExpression[] { f }));

  // // Umwandeln des Expression Tree in eine Abfrage
  // var Q3 = Q2.Provider.CreateQuery<Flug>(whereCallExpression);

  // // Zum Test
  // Console.WriteLine("Nach Where: " + ((ObjectQuery)Q3).ToTraceString());


  // foreach (var Flug in Q3)
  // {
  //  Console.WriteLine("Flug Nr {0} von {1} nach {2}!", Flug.FlugNr, Flug.Abflugort, Flug.Zielort);
  // }


  // db.SaveChanges();
  // db.Dispose();
  //}


 }
}
