﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects;

namespace de.WWWings.Test.Modelle.EF_WWWings6_EigenesT4
{

 /// <summary>
 /// Dies ist der Erweiterungscode, der entweder über die T4-Vorlage automatisch generiert wird oder aber hier manuell anheftet wird. Dann muss die Klasse WWWings6_EigenesT4 heißen
 /// </summary>
 public partial class WWWings6_EigenesT4
 {


  /// <summary>
  ///  Erzeuge Eintrag für Protokoll-Tabelle
  /// </summary>
  public Protokoll CreateProtokoll(string Entity, int EntityID, string Aktion, string Attribut, string AlterWert, string NeuerWert, string Text)
  {
   Protokoll p = new Protokoll();
   p.Entity = Entity;
   p.EntityID = EntityID;
   p.Aktion = Aktion;
   p.Attribut = Attribut;
   p.AlterWert = AlterWert;
   p.NeuerWert = NeuerWert;
   p.Text = "";
   p.Computer = System.Environment.MachineName;
   p.Benutzer = System.Environment.UserName;
   p.Zeit = DateTime.Now;
   return p;
  }

  /// <summary>
  /// Überschriebene Variante von SaveChanges mit Protokollierung!!!
  /// </summary>
  public override int SaveChanges(System.Data.Objects.SaveOptions options)
  {
   List<Protokoll> ProtokolEintragsCache = new List<Protokoll>();
   List<ObjectStateEntry> neue = new List<ObjectStateEntry>();
   // Hole Geänderte
   foreach (var ose in this.ObjectStateManager.GetObjectStateEntries(System.Data.EntityState.Modified))
   {
    foreach (var mprop in ose.GetModifiedProperties())
    {
     ProtokolEintragsCache.Add(CreateProtokoll(ose.EntitySet.Name, (int)ose.EntityKey.EntityKeyValues[0].Value, "Modified", mprop, ose.OriginalValues[mprop].ToString(), ose.CurrentValues[mprop].ToString(), ""));
    }
   }

   // Hole Neue
   foreach (var ose in this.ObjectStateManager.GetObjectStateEntries(System.Data.EntityState.Added))
   {
    // Erstmal nur merken, denn die Autowerte sind noch nicht gesetzt!
    neue.Add(ose);
   }

   // Hole Gelöschte
   foreach (var ose in this.ObjectStateManager.GetObjectStateEntries(System.Data.EntityState.Deleted))
   {

    ProtokolEintragsCache.Add(CreateProtokoll(ose.EntitySet.Name, (int)ose.EntityKey.EntityKeyValues[0].Value, "Deleted", "", "", "", ""));

   }

   int Anzahl = base.SaveChanges(options);

   // Jetzt noch die neuen behandeln
   foreach (var ose in neue)
   {
    if (ose.EntityKey.EntityKeyValues != null) ProtokolEintragsCache.Add(CreateProtokoll(ose.EntitySet.Name, (int)ose.EntityKey.EntityKeyValues[0].Value, "Added", "", "", "", ""));
   }

   // jetzt die Protokolleinträge erst anhängen, sonst Rekursion!
   foreach (var p in ProtokolEintragsCache)
   {
    Console.WriteLine("Protokoll: Objekt {0} Aktion {1} Attribut {2} Alt {3} Neu {4}", p.Entity + "_" + p.EntityID, p.Aktion, p.Attribut, p.AlterWert, p.NeuerWert);
    this.Protokoll.AddObject(p);
   }
   int x = base.SaveChanges(options);

   return Anzahl;
  }
 }
}
