using System;
using System.Collections.Generic;
using System.Text;
using OpenAccess;
using OpenAccess.Query;

namespace VOA_Demo
{
 class Program
 {
  static void Main(string[] args)
  {

   D2_LINQ();
   //D4_Navigation();
   //D3_ReadWrite();
   //D5_Disconnect_Einzelobjekt();
   //D5_Disconnect_Menge();


   #region Speed
   //for (int i = 1; i <= 10; i++)
   //{
   // ITV.Timer.Start("VOA");

   // VOA_Speed();

   // ITV.Timer.End();

   //}

   //ITV.Timer.Results();

   #endregion

   Console.ReadLine();


  }

  private static void VOA_Speed()
  {
   IObjectScope scope =
   Database.Get("DatabaseConnection1").GetObjectScope();

   string query;

   query = "SELECT * FROM FlugExtent as Flug";
   IQueryResult result =
      scope.GetOqlQuery(query).Execute();

   foreach (Flug c in result)
   {
    int i = c.FLFlugNr;
   }
   result.Dispose();

  }


  /// <summary>
  /// LINQ bei Vanatec
  /// </summary>
  private static void D2_LINQ()
  {

   IObjectScope scope =
Database.Get("DatabaseConnection1").GetObjectScope();

   var q = from f in scope.Extent<Flug>() where f.FLAbflugort == "Rom" && f.FLFlugNr <=1000 select f;
   foreach (Flug c in q)
   {
    Console.WriteLine("Flug " + c.FLFlugNr + " fliegt von " + c.FLAbflugort + " nach " + c.FLZielort);

    foreach (GebuchterFlug b in c.GebuchterFlugs)
    {
    

     Console.WriteLine("- " + b.GFBuchungscode + " " + b.PSPassagier.PEPerson.PEName);
    }

    scope.Transaction.Begin();
    Console.WriteLine("Vorher: " + c.FLFreiePlaetze);
    //Console.WriteLine(scope.IsDirty(c));
    c.FLFreiePlaetze--;

    //Console.WriteLine(scope.IsDirty(c));
    scope.Transaction.Commit();
    Console.WriteLine("Nachher: " + c.FLFreiePlaetze);

   }
   scope.Dispose();
  }



  private static void D3_ReadWrite()
  {

   IObjectScope scope =
   Database.Get("DatabaseConnection1").GetObjectScope();

   string query;

   // query = "SELECT * FROM FlugExtent as Flug ";
   query = "SELECT * FROM FlugExtent as Flug where Flug.FLFlugNr < 110 ";


   query = "SELECT * FROM FlugExtent as Flug where Flug.FLAbflugort = 'Rom'";
   IQueryResult result = scope.GetOqlQuery(query).Execute();
   foreach (Flug c in result)
   {
    Console.WriteLine("Flug " + c.FLFlugNr + " fliegt von " + c.FLAbflugort + " nach " + c.FLZielort);

    foreach (GebuchterFlug b in c.GebuchterFlugs)
    {
     //Console.WriteLine(b.GFBuchungscode);
    }
    scope.Transaction.Begin();
    Console.WriteLine(c.FLFreiePlaetze);
    //Console.WriteLine(scope.IsDirty(c));
    c.FLFreiePlaetze--;

    //Console.WriteLine(scope.IsDirty(c));
    scope.Transaction.Commit();
    Console.WriteLine(c.FLFreiePlaetze);

   }
   result.Dispose();
  }


  /// <summary>
  /// Objektnavigation
  /// </summary>
  private static void D4_Navigation()
  {

   IObjectScope scope =
   Database.Get("DatabaseConnection1").GetObjectScope();

   string query;
   //= "SELECT * FROM FlugExtent as Flug where Flug.FLAbflugort = 'Rom'";
   // query = "SELECT * FROM FlugExtent as Flug ";
   query = "SELECT * FROM FlugExtent as Flug where Flug.FLFlugNr < 110 ";
   IQueryResult result =
      scope.GetOqlQuery(query).Execute();

   foreach (Flug c in result)
   {
    Console.WriteLine("Flug " + c.FLFlugNr + " fliegt von " + c.FLAbflugort + " nach " + c.FLZielort);

    foreach (GebuchterFlug b in c.GebuchterFlugs)
    {
     Console.WriteLine("-" + b.GFBuchungscode);
    }

   }
   result.Dispose();
  }


  /// <summary>
  /// VOA im Mehrschichtszenario
  /// </summary>
  private static void D5_Disconnect_Einzelobjekt()
  {

   IObjectScope scope =
   Database.Get("DatabaseConnection1").GetObjectScope();

   string query;
   //= "SELECT * FROM FlugExtent as Flug where Flug.FLAbflugort = 'Rom'";
   // query = "SELECT * FROM FlugExtent as Flug ";
   query = "SELECT * FROM FlugExtent as Flug where Flug.FLFlugNr = 101 ";
   IQueryResult result =
      scope.GetOqlQuery(query).Execute();

   Flug f = result[0] as Flug;

   scope.Transaction.Begin();

   // Container erzeugen
   ObjectContainer c = new ObjectContainer();
   c.CopyFrom(scope, "fluege", f, null);
   scope.Transaction.Commit();

   int i = f.FLFlugNr;
   scope.Dispose();

   Console.WriteLine("DISCONNECTED!");

   IObjectId id = c.GetObjectId(f);
   Flug f2 = c.GetObjectById(id) as Flug;
   Console.WriteLine(f2.FLFreiePlaetze);
   Console.WriteLine(c.IsDirty(f2));

   c.Transaction.Begin();
   f2.FLDatum = DateTime.Now;
   f2.FlStartZeit = DateTime.Now;
   f2.FlAnkunftszeit = DateTime.Now;
   f2.FLEingerichtetAm = DateTime.Now;
   f2.FLFreiePlaetze--;
   Console.WriteLine(c.IsDirty(f2));
   c.Transaction.Commit();


   Console.WriteLine(scope.IsDirty(f2));
   Console.WriteLine(f2.FLFreiePlaetze);

   Console.WriteLine("--- New Scope:");


   IObjectScope scope2 =
  Database.Get("DatabaseConnection1").GetObjectScope();
   scope2.Transaction.Begin();
   c.CopyTo(scope2, OpenAccess.ObjectContainer.Verify.Changed);
   scope2.Transaction.Commit();

   Console.Write("Saved!");

  }


  /// <summary>
  /// VOA im Mehrschichtszenario
  /// </summary>
  private static void D5_Disconnect_Menge()
  {

   IObjectScope scope =
   Database.Get("DatabaseConnection1").GetObjectScope();

   string query;
   //= "SELECT * FROM FlugExtent as Flug where Flug.FLAbflugort = 'Rom'";
   // query = "SELECT * FROM FlugExtent as Flug ";
   query = "SELECT * FROM FlugExtent as Flug where Flug.FLFlugNr < 110 ";
   IQueryResult result =
      scope.GetOqlQuery(query).Execute();

   scope.Transaction.Begin();

   // Container erzeugen
   ObjectContainer c = new ObjectContainer();
   c.CopyFrom(scope, "fluege", result, null);
   scope.Transaction.Commit();
   IObjectId id = c.GetObjectId(result[5]);
   scope.Dispose();

   Console.WriteLine("DISCONNECTED!");

   // Client
   Flug f2 = c.GetObjectById(id) as Flug;
   Console.WriteLine(f2.FLFreiePlaetze);
   Console.WriteLine(c.IsDirty(f2));

   c.Transaction.Begin();
   f2.FLDatum = DateTime.Now;
   f2.FlStartZeit = DateTime.Now;
   f2.FlAnkunftszeit = DateTime.Now;
   f2.FLEingerichtetAm = DateTime.Now;
   f2.FLFreiePlaetze--;
   Console.WriteLine(f2.FLFreiePlaetze);
   Console.WriteLine(c.IsDirty(f2));
   c.Transaction.Commit();
   Console.WriteLine("--- New Scope:");

   OpenAccess.ObjectContainer.ChangeSet changeset = 
    c.GetChanges(ObjectContainer.Verify.Changed);

   //Console.WriteLine("nderungen: " + changeset.ToString());


   // Zurck auf dem Server
   IObjectScope scope2 = Database.Get("DatabaseConnection1").GetObjectScope();
   ObjectContainer.ChangeSet changeset2 = ObjectContainer.CommitChanges(changeset,
      ObjectContainer.Verify.Changed, scope2, true, true);


   Console.Write("Saved!");

  }

 }
}

