using System;
using System.Collections.Generic;
using System.Text;
using de.ITVisions.DemoViewer;

namespace VerschiedeneDemos_CS.FCL3
{
 [Demo]
public class FCLSerialiasierung_Objektmodell
 {
  // === Beispiele fr Binres und XML serialisieren
  public void OModell_Serialisieren()
  {

   // --- Objektmodell aufbauen
   Buchautor a = new Buchautor("Holger Schwichtenberg");
   a.Geb = DateTime.Parse("8/1/1972");
   a.PLZ = 45257;
   a.Wohnort = "Essen";

   Verlag v = new Verlag();
   v.Name = "Addison Wesley";

   Buch b1 = new Buch("Windows Scripting");

   b1.Auflagen.Add(new Auflage(1, 2000, "3-8273-1637-5"));
   b1.Auflagen.Add(new Auflage(2, 2001, "3-8273-1843-2"));
   b1.Auflagen.Add(new Auflage(3, 2002, "3-8273-2061-5"));
   b1.Verlag = v;

   Buch b2 = new Buch("ASP.NET - Das Entwicklerbuch");

   b2.Auflagen.Add(new Auflage(1, 2002, "3-86063-667-7"));
   b2.Verlag = new Verlag("MSPress");

   Buch b3 = new Buch("Programmieren mit der .NET-Klassenbibliothek");
   b3.Auflagen.Add(new Auflage(1, 2002, "3-8273-1905-6"));
   b3.Verlag = v;

   a.buecher.Add(b2);
   a.buecher.Add(b1);
   a.buecher.Add(b3);

   // --- Variante: zweifacher Verweis auf ein Objekt
   //a.b1 = b1
   //a.b2 = b1

   // --- Objektmodell ausgeben
   autorinfo(a);

   object o = null; // Objekt fr Deserialisierung

   // --- Serialisierungsziele
   const string DATEI = "c:\\Temp\\buch.bin";
   const string DATEISOAP = "c:\\Temp\\buch.soap.xml";
   const string DATEIXML = "c:\\Temp\\buch.xml";
   const string DATEIDATACONTRACT = "c:\\Temp\\buch.dc.xml";
   const string DATEINETDATACONTRACT = "c:\\Temp\\buch.ndc.xml";
   // --- XML-Serialisieren
   Demo.PrintHeader("XML Serialisierung...");
   UniversalSerialisierer.Save(SerialTyp.XML, a, DATEIXML);
   o = UniversalSerialisierer.load(SerialTyp.XML, DATEIXML, typeof(Buchautor));
   autorinfo(o);


   // --- Datacontract-Serialisieren
   Demo.PrintHeader("Datacontract Serialisierung...");
   UniversalSerialisierer.Save(SerialTyp.DATACONTRACT, a, DATEIDATACONTRACT);
   //o = UniversalSerialisierer.load(SerialTyp.DATACONTRACT, DATEIDATACONTRACT, typeof(Buchautor));
   //autorinfo(o);



   // --- Datacontract-Serialisieren
   Demo.PrintHeader("NetDatacontract Serialisierung...");
   UniversalSerialisierer.Save(SerialTyp.NETDATACONTRACT, a, DATEINETDATACONTRACT);
   o = UniversalSerialisierer.load(SerialTyp.NETDATACONTRACT, DATEINETDATACONTRACT, typeof(Buchautor));
   autorinfo(o);


   // --- binre Serialisieren
   Demo.PrintHeader("Binre Serialisierung...");
  UniversalSerialisierer.Save(SerialTyp.BINARY, a, DATEI);
  o = UniversalSerialisierer.Load(SerialTyp.BINARY, DATEI);
   autorinfo(o);

   // --- binre Serialisieren
   Demo.PrintHeader("Binre Serialisierung...");
   UniversalSerialisierer.Save(SerialTyp.SOAP, a, DATEISOAP);
   o = UniversalSerialisierer.Load(SerialTyp.SOAP, DATEISOAP);
   autorinfo(o);

   



   // --- Anlegen einer zirkulren Referenz
   b1.Autor = a;
   b2.Autor = a;
   b3.Autor = a;

   // --- binre Serialisieren
   Demo.PrintHeader("Binre Serialisierung mit zirkulrer Referenz...");
   UniversalSerialisierer.Save(SerialTyp.BINARY, a, DATEI);
   // --- Deserialisieren
   a = (Buchautor) UniversalSerialisierer.Load(SerialTyp.BINARY, DATEI);
   autorinfo(a);

   // --- binre Serialisieren
   Demo.PrintHeader("SOAP Serialisierung  mit zirkulrer Referenz...");
   UniversalSerialisierer.Save(SerialTyp.SOAP, a, DATEISOAP);
   // --- Deserialisieren
   a = (Buchautor)UniversalSerialisierer.Load(SerialTyp.BINARY, DATEI);
   autorinfo(a);

   ////' --- XML-Serialisieren
   //Demo.PrintHeader("XML Serialisierung  mit zirkulrer Referenz...");
   //try
   //{
   // UniversalSerialisierer.save(SerialTyp.XML, a, DATEIXML);
   // a = (Buchautor)UniversalSerialisierer.load(SerialTyp.XML, DATEIXML, typeof(Autor));
   // autorinfo(a);
   //}
   //catch (Exception e)
   //{
   // Demo.PrintError("Serialisierung nicht mglich: " + e.Message);
   //}

   // --- Datacontract-Serialisieren
   Demo.PrintHeader("Datacontract Serialisierung...");
   try
   {
    UniversalSerialisierer.Save(SerialTyp.DATACONTRACT, a, DATEIDATACONTRACT);
    o = UniversalSerialisierer.load(SerialTyp.DATACONTRACT, DATEIDATACONTRACT, typeof(Buchautor));
    autorinfo(o);
   }
   catch (Exception e)
   {
    Demo.PrintError("Serialisierung nicht mglich: " + e.Message);
   }

   // --- Datacontract-Serialisieren
   Demo.PrintHeader("NetDatacontract Serialisierung...");
   try
   {
    UniversalSerialisierer.Save(SerialTyp.NETDATACONTRACT, a, DATEINETDATACONTRACT);
    o = UniversalSerialisierer.load(SerialTyp.NETDATACONTRACT, DATEINETDATACONTRACT, typeof(Buchautor));
    autorinfo(o);
   }
   catch (Exception e)
   {
    Demo.PrintError("Serialisierung nicht mglich: " + e.Message);
   }

  }

  // === Ausgabe des Objektmodell
  public static void autorinfo(object o)
  {
   Buchautor a = (Buchautor)o;
   //INSTANT C# NOTE: Commented this declaration since looping variables in 'foreach' loops are declared in the 'foreach' header in C#
   //  Buch b = null;
   Demo.Print("Autor: " + a.Name + ", " + a.buecher.Count + " Bcher");
   foreach (Buch b in a.buecher)
   {
    Demo.Print("Buch: " + b.Titel);
    if (b.Autor != null)
     Demo.Print("von " + b.Autor.Name);
   }
  }

 }
}
