using System;
using System.Collections.Generic;
using System.Text;
using de.ITVisions.DemoViewer;

namespace NET2.SpracheCSharp
{
 [Demo]
 public class DelegateBeispiel1
 {
  // Eigener Delegate
  public delegate string Begruessung(string name, string vorname);

  static void Run()
  {
   string e;

   // Verwendung eigener Delegate
   Begruessung g = Hallo;

   e = g("Schwichtenberg", "Holger");
   Console.WriteLine(e);
   g = GutenTag;
   e = g("Schwichtenberg", "Holger");
   Console.WriteLine(e);

   // Verwendung vordefinierter Delegate
   Action<string> start = Start;
   start("test");

   Console.ReadLine();
  }

  // Implementierng #1 Delegate Begruessung<T,T>
  static public string Hallo(string name, string vorname)
  {
   return "Hallo " + vorname + " " + name + "!";
  }

  // Implementierng #2 Delegate Begruessung<T,T>
  static public string GutenTag(string name, string vorname)
  {
   return "Guten Tag " + vorname + " " + name + "!";
  }

  // Implementierng Delegate Action<t>
  static public void Start(string x)
  {
   Console.WriteLine("Starte: " + x);
  }

 }

 [Demo]
 public class DelegateBeispiel2
 {
  // === Funktion
  public string HoleWert(long Parameter)
  {
   Demo.Print("Methodenaufruf...");
   return "Wert " + Parameter;
  }
  // === Definition eines Funktionszeigertyps
  public delegate string HoleWertDelegate(long Parameter);
  // === Hauptprogramm
  public void Test()
  {
   // --- Synchroner Aufruf
   Demo.Print("Asynchroner Aufruf...");
   Demo.Print("Ergebnis: " + HoleWert(2));
   // --- Asynchroner Aufruf
   Demo.Print("Asynchroner Aufruf...");
   HoleWertDelegate del = new HoleWertDelegate(this.HoleWert);
   AsyncCallback Callback = new AsyncCallback(Fertig);
   del.BeginInvoke(123, Callback, del);
   // --- Warten
   for (int a = 1; a <= 10; a++)
   {
    Console.Write("*");
    System.Threading.Thread.Sleep(100);
   }
   Console.ReadLine();
  }
  // === Callback-Handler
  public void Fertig(IAsyncResult CallbackResult)
  {
   Demo.Print("Aufruf fertig...");
   HoleWertDelegate del = (HoleWertDelegate)CallbackResult.AsyncState;
   string Ergebnis = del.EndInvoke(CallbackResult);
   Demo.Print("Ergebnis: " + Ergebnis);
  }
 }

}
