﻿'Option Strict On

Imports WWWings_GL_DZS_CS
Imports WWWings35_GO
Imports System
Imports System.Xml.Linq

Namespace NET3.SpracheVB


 Public Class VB08_XMLLiterals



  Sub Main()
   'XML_Fluege_Inline()
   XML_Literal_Demo_Fragment()
   'XML_Fluege_Convert()
   Console.ReadLine()
  End Sub


  Shared Sub XML_Literal_Demo_Fragment()

   ' Ein XML-Fragment kann man einfach definieren...

   Dim x As XElement = _
 <Flug ID="347">
  <Abflugort>Madrid</Abflugort>
  <Zielort>Paris</Zielort>
  <FreiePlaetze>1</FreiePlaetze>
  <Details>
   <Nichtraucher>True</Nichtraucher>
   <Plaetze>250</Plaetze>
   <EingerichtetAm/>
  </Details>
  <Passagiere>
   <Passagier>Müller</Passagier>
   <Passagier>Meier</Passagier>
   <Passagier>Schulze</Passagier>
  </Passagiere>
 </Flug>

   ' und  einfach verwenden:
   ' Zugriff auf ein Attribut
   Console.WriteLine(x.@ID)
   ' Zugriff auf Elemente

   Console.WriteLine(x.<Abflugort>.Value) ' Madrid
   Console.WriteLine(x.<Zielort>.Value) '  Paris
   Console.WriteLine(x.<Details>.<Plaetze>.Value) ' 250
   Console.WriteLine(x.<Passagiere>.<Passagier>(0).Value) ' = Müller!
   Console.WriteLine(x.<Passagiere>.<Passagier>(1).Value) ' = Meier!
   ' Schleife über Elemente
   For Each p As XElement In x.<Passagiere>.<Passagier>
    Console.WriteLine(p.Value)
   Next

  End Sub

  Shared Sub XML_Literal_Demo_Document()
   Dim d As XDocument = _
 <?xml version="1.0" encoding="UTF-8" standalone="yes"?>
 <Fluege>
  <Flug ID="347">
   <Abflugort>Madrid</Abflugort>
   <Zielort>Paris</Zielort>
   <FreiePlaetze>1</FreiePlaetze>
   <Details>
    <Nichtraucher>True</Nichtraucher>
    <Plaetze>250</Plaetze>
    <EingerichtetAm/>
   </Details>
  </Flug>
  <Flug ID="220">
   <Abflugort>Madrid</Abflugort>
   <Zielort>Paris</Zielort>
   <FreiePlaetze>1</FreiePlaetze>
   <Details>
    <Nichtraucher>True</Nichtraucher>
    <Plaetze>250</Plaetze>
    <EingerichtetAm/>
   </Details>
  </Flug>
 </Fluege>

   Dim e2 As XElement = d.Document.Root
   Console.WriteLine(d.Document.Root.<Flug>(1).@ID)
  End Sub


  Shared Sub XML_Fluege_Select()

   ' Natürlich kann man Dokumente laden...
   Dim doc As XElement = XElement.Load("flugliste.xml")

   ' und LINQ einsetzen zum Abfragen
   Dim query As XElement = _
       From i In doc.<Fluege>.<Flug> _
       Where i.<FreiePlaetze>(0).Value > 100 _
       Select i

   For Each result As XElement In query.<Flug>
    Console.WriteLine(result.@ID.ToString() & "=" & _
                      result.<FreiePlaetze>(0).Value)
   Next
  End Sub

  ''' <summary>
  ''' Verändern eines XML-Dokuments
  ''' </summary>
  Public Shared Sub XML_Fluege_Change()
   ' Bestehende Flugliste laden
   Dim Fluege As XElement = XElement.Load("_Daten/flugliste.xml")

   ' LINQ mit einem Ergebnisknoten
   Dim flug As XElement = (From f In Fluege.<Flug> _
                           Where f.@ID = 101 _
                           Select f).FirstOrDefault()

   If flug Is Nothing Then ' Kein Flug gefunden
    Return
   End If

   ' Freie Plätze reduzieren
   Console.WriteLine("Freie Plätze vorher: " & flug.<FreiePlaetze>.Value)
   flug.<FreiePlaetze>.Value -= 1
   Console.WriteLine("Freie Plätze nachher: " & flug.<FreiePlaetze>.Value)

   ' Liste komplett (!) speichern
   Fluege.Save("_Daten/flugliste.xml")
   Console.WriteLine("Gespeichert: " & Fluege.ToString())
  End Sub

  'Sub XML_Counter_Select()
  ' Dim doc = XDocument.Load("counter.xml")

  ' Dim query = _
  '     From i In doc.<counter>.<url> _
  '     Where i.<count>(0).Value > 1 _
  '     Select i

  ' Console.WriteLine(query)

  ' For Each result In query
  '  Console.WriteLine(result.@name.ToString() & "=" & result.<count>(0).Value)
  ' Next
  'End Sub

  'Sub XML_Fluege_Convert()

  ' ' --- Einlesen aus Datenbank
  ' Dim db As New WWWingsDataContext
  ' Dim fluege As List(Of Flug)
  ' fluege = (From f In db.Flugs Select f).ToList()
  ' Console.WriteLine(fluege.Count)

  ' ' --- Exportieren in XML
  ' Dim e As XElement = _
  ' <Fluege>
  '  <%= From f In fluege _
  '   Where f.Abflugort = "Rom" _
  '   Select <Flug id=<%= f.FlugNr %>>
  '           <AbflugOrt><%= f.Abflugort %></AbflugOrt>
  '           <ZielOrt><%= f.Zielort %></ZielOrt>
  '           <Plaetze><%= f.FreiePlaetze %></Plaetze>
  '          </Flug> %>
  ' </Fluege>
  ' e.Save("Flugdatenexport.xml")

  ' Console.WriteLine(e)

  'End Sub

  'Sub XML_Fluege_Inline()
  ' Dim doc = XDocument.Load("flugliste.xml")
  ' For Each result In doc.<Fluege>.<Flug>
  '  Console.WriteLine(result.@ID.ToString() & "=" & _
  '                    result.<FreiePlaetze>(0).Value)
  ' Next
  'End Sub



  'Sub XML_Inline()
  ' Dim doc = XDocument.Load("counter.xml")

  ' For Each result In doc.<counter>.<url>
  '  Console.WriteLine(result.@name.ToString() & "=" & result.<count>(0).Value)
  ' Next
  'End Sub

  'Sub LINQ_Select()
  ' Dim db As New WWWingsDataContext

  ' Dim q = From f In db.Flugs _
  '         Where f.Abflugort = "ROM" _
  '         Select f

  ' For Each flug In q
  '  Console.WriteLine(flug.Abflugort)
  ' Next
  'End Sub
 End Class
End Namespace