DROP TABLE WWWings.Person   CASCADE CONSTRAINTS;
DROP TABLE WWWings.Passagier CASCADE CONSTRAINTS;
DROP TABLE WWWings.Mitarbeiter  CASCADE CONSTRAINTS;
DROP TABLE WWWings.Flug_Passagier  CASCADE CONSTRAINTS;
DROP TABLE WWWings.Flug  CASCADE CONSTRAINTS;
DROP TABLE WWWings.Pilot  CASCADE CONSTRAINTS;

CREATE TABLE WWWings.Person  
(
	PersonID int  NOT NULL , 
	Name NVARCHAR2 (50) NOT NULL , 
	Vorname NVARCHAR2 (50) NOT NULL , 
	Land NVARCHAR2 (2)  NULL , 
	Geburtstag DATE   NULL , 
	Foto BLOB   NULL , 
	EMail NVARCHAR2 (50)  NULL , 
	Stadt NVARCHAR2 (30)  NULL , 
	Memo CLOB   NULL , 
	Geburtsort NVARCHAR2 (30)  NULL , 
	CONSTRAINT PK_Person PRIMARY KEY (PersonID) 
);
Commit;
CREATE TABLE WWWings.Passagier  
(
	PersonID int  NOT NULL , 
	KundeSeit DATE   NULL , 
	KundenStatus nchar (1)  NULL , 
	CONSTRAINT PK_Passagier PRIMARY KEY (PersonID) 
);
Commit;
CREATE TABLE WWWings.Mitarbeiter  
(
	PersonID int  NOT NULL , 
	MitarbeiterNr int   NULL , 
	Einstellungsdatum DATE   NULL , 
	VorgesetzterPersonID int   NULL , 
	CONSTRAINT PK_Mitarbeiter PRIMARY KEY (PersonID) 
);
Commit;
CREATE TABLE WWWings.Pilot  
(
	PersonID int  NOT NULL , 
	FlugscheinSeit DATE   NULL , 
	Flugscheintyp nchar (1)  NULL , 
	Flugstunden int   NULL , 
	Flugschule NVARCHAR2 (50)  NULL , 
	CONSTRAINT PK_Pilot PRIMARY KEY (PersonID) 
);
Commit;
CREATE TABLE WWWings.Flug  
(
	FlugNr int  NOT NULL , 
	Abflugort NVARCHAR2 (20) NOT NULL , 
	Zielort NVARCHAR2 (20) NOT NULL , 
	Datum DATE  NOT NULL , 
	NichtRaucherFlug NUMBER (1) NOT NULL , 
	Plaetze smallint  NOT NULL , 
	FreiePlaetze smallint   NULL , 
	Pilot_PersonID int   NULL , 
	Ankunft DATE   NULL , 
	Memo CLOB   NULL , 
	test nchar (10)  NULL , 
	CONSTRAINT PK_Flug PRIMARY KEY (FlugNr) 
);
Commit;
CREATE TABLE WWWings.Flug_Passagier  
(
	Flug_FlugNr int  NOT NULL , 
	Passagier_PersonID int  NOT NULL , 
	CONSTRAINT PK_Flug_Passagier PRIMARY KEY (Flug_FlugNr, Passagier_PersonID) 
);
Commit;
ALTER TABLE WWWings.Flug 
ADD
	CONSTRAINT FK_FL_Flug_PI_Pilot FOREIGN KEY (Pilot_PersonID) REFERENCES WWWings.Pilot (PersonID); 
	Commit;
ALTER TABLE WWWings.Flug_Passagier 
ADD
	CONSTRAINT FK_Flug_Passagier_Flug FOREIGN KEY (Flug_FlugNr) REFERENCES WWWings.Flug (FlugNr); 
	Commit;
ALTER TABLE WWWings.Flug_Passagier 
ADD
	CONSTRAINT FK_Flug_Passagier_Passagier FOREIGN KEY (Passagier_PersonID) REFERENCES WWWings.Passagier (PersonID); 
	Commit;
ALTER TABLE WWWings.Mitarbeiter 
ADD
	CONSTRAINT FK_MI_Mitarbeiter_PE_Person FOREIGN KEY (PersonID) REFERENCES WWWings.Person (PersonID); 
	Commit;
ALTER TABLE WWWings.Mitarbeiter 
ADD
	CONSTRAINT FK_Mitarbeiter_Mitarbeiter FOREIGN KEY (VorgesetzterPersonID) REFERENCES WWWings.Mitarbeiter (PersonID); 
	Commit;
ALTER TABLE WWWings.Passagier 
ADD
	CONSTRAINT FK_PS_Passagier_PE_Person FOREIGN KEY (PersonID) REFERENCES WWWings.Person (PersonID); 
Commit;
ALTER TABLE WWWings.Pilot 
ADD
	CONSTRAINT FK_PI_Pilot_MI_Mitarbeiter FOREIGN KEY (PersonID) REFERENCES WWWings.Mitarbeiter (PersonID);